// Code10A: Reconfigurable Mesh
#include "Code10A.h"

BEGIN_MESSAGE_MAP(CCode10A,CFrameWnd)
	ON_WM_PAINT()       
	ON_WM_LBUTTONDOWN() 
END_MESSAGE_MAP()

CCode10A::CCode10A()
{
	int i,j;
	int pColor[]={RGB(0,0,200),RGB(255,0,0),RGB(0,150,0),
		RGB(255,50,255),RGB(0,0,150),RGB(200,200,0),RGB(0,200,200),
		RGB(55,0,255),RGB(0,150,0),RGB(0,100,255)};
	Create(NULL,L"Reconfigurable Mesh Model",WS_OVERLAPPEDWINDOW,
		CRect(0,0,750,550));
	cPos.status=0;		// b=begin
	BusColor=0;
	Node[1][1].home=CPoint(30,20);
	Node[1][1].rct=CRect(Node[1][1].home,Node[1][1].home+CPoint(50,50));
	for (j=1;j<=M;j++)
		for (i=1;i<=N;i++)
		{
			Node[i][j].home=Node[1][1].home
				+CPoint((rSIZE+rSPACING)*(i-1),(rSIZE+rSPACING)*(j-1));
			Node[i][j].rct=CRect(Node[i][j].home,
				Node[i][j].home+CPoint(rSIZE,rSIZE));
			Node[i][j].w=Node[i][j].home+CPoint(0,rSIZE/2);
			Node[i][j].e=Node[i][j].home+CPoint(rSIZE,rSIZE/2);
			Node[i][j].n=Node[i][j].home+CPoint(rSIZE/2,0);
			Node[i][j].s=Node[i][j].home+CPoint(rSIZE/2,rSIZE);
		}
	for (i=0;i<=9;i++)
		pBus[i].CreatePen(PS_SOLID,2,pColor[i]);
}

void CCode10A::OnPaint()
{
	int i,j;
	CString s;
	CRect cPort;
	CPoint a,b;
	CPaintDC dc(this);
	CFont fArial;
	fArial.CreatePointFont (60,L"Arial");

	// draw the PEs and their ports
	dc.SelectObject(fArial);
	for (j=1;j<=M;j++)
		for (i=1;i<=N;i++)
		{
			dc.Rectangle(&Node[i][j].rct);
			s.Format(L"%d,%d",i,j); 
			dc.TextOutW(Node[i][j].home.x,Node[i][j].home.y-10,s);
			DrawPort(i,j,Node[i][j].w);
			DrawPort(i,j,Node[i][j].e);
			DrawPort(i,j,Node[i][j].n);
			DrawPort(i,j,Node[i][j].s);
		}

	// draw the grid lines
	for (j=1;j<=M;j++)
		for (i=1;i<=N;i++)
		{
			// horizontal grids
			if (i!=N)
			{
				a=Node[i][j].e+CSize(pSIZE/2,0);
				b=Node[i+1][j].w-CSize(pSIZE/2,0);
			}
			// vertical grids
			if (j!=M)
			{
				a=Node[i][j].s+CSize(0,pSIZE/2);
				b=Node[i][j+1].n-CSize(0,pSIZE/2);
			}
			dc.MoveTo(a); dc.LineTo(b);
		}

	// draw the buses whenever a PE is clicked
	if (cPos.status)		// if active
	{
		dc.SelectObject (&pBus[BusColor]);			
		dc.MoveTo(cPos.joint); 
		dc.LineTo(cPos.A); dc.LineTo(cPos.B);
		if (cPos.dir==1)		// eastbound
			cPos.jointPort=2;
		if (cPos.dir==2)		// westbound
			cPos.jointPort=1;
		if (cPos.dir==4)		// southbound
			cPos.jointPort=3;
		if (cPos.dir==3)		// northbound
			cPos.jointPort=4;
	}
	if (!cPos.status)		// first time clicked
	{
		dc.SelectObject(&pBus[BusColor]);
		if (cPos.dir==5)		// terminate eastward
		{
			dc.MoveTo(cPos.joint); 
			dc.LineTo(cPos.A); dc.LineTo(cPos.B);			
		}
		if ((cPos.cI==1 || cPos.cI==N) || (cPos.cJ==1 || cPos.cJ==M))
		{
			if (cPos.cI==1)
				cPos.jointPort=2;
			if (cPos.cI==N)
				cPos.jointPort=1;
			if (cPos.cJ==1)
				cPos.jointPort=3;
			if (cPos.cJ==M)
				cPos.jointPort=4;
			dc.MoveTo(cPos.A); dc.LineTo(cPos.B);
			cPos.status=1; 
		}
	}
}

void CCode10A::DrawPort(int i,int j,CPoint Q)
{
	CClientDC dc(this);
	CRect rct;
	rct=CRect(Q-CSize(pSIZE/2,pSIZE/2),Q+CSize(pSIZE/2,pSIZE/2));
	dc.Ellipse(&rct);
}

void CCode10A::OnLButtonDown (UINT nFlags,CPoint pt)
{
	int i,j;
	CPoint OutUpLeft,OutDownRight;
	CPoint InUpLeft,InDownRight;
	CRect OutsideRect,InsideRect;
	cPos.pI=cPos.cI; cPos.pJ=cPos.cJ;
	cPos.cI=1+(pt.x-30)/(rSIZE+rSPACING); 
	cPos.cJ=1+(pt.y-30)/(rSIZE+rSPACING);
	if (Node[cPos.cI][cPos.cJ].rct.PtInRect(pt))
	{
		if (cPos.status)
		{
			if (cPos.cI-cPos.pI==1 && cPos.cJ==cPos.pJ)
			{
				cPos.dir=1;			// eastbound
				cPos.joint=cPos.B;
				cPos.A=Node[cPos.pI][cPos.pJ].e;
				cPos.B=Node[cPos.cI][cPos.cJ].w;
				if (cPos.jointPort==3)
				{
					InUpLeft=cPos.joint;
					InDownRight=cPos.A;
				}
				if (cPos.jointPort==2)
				{
					InUpLeft=cPos.joint+CPoint(0,-1);
					InDownRight=cPos.A+CPoint(0,1);
				}
				if (cPos.jointPort==4)
				{
					InUpLeft=cPos.joint+CPoint(0,-rSIZE/2);
					InDownRight=cPos.A+CPoint(0,rSIZE/2);
				}					
				OutUpLeft=cPos.A+CPoint(0,-rSIZE/2);
				OutDownRight=cPos.B+CPoint(0,rSIZE/2);
			} 
			if (cPos.cI-cPos.pI==-1 && cPos.cJ==cPos.pJ)
			{ 
				cPos.dir=2;			// westbound
				cPos.joint=cPos.B;
				cPos.A=Node[cPos.pI][cPos.pJ].w;
				cPos.B=Node[cPos.cI][cPos.cJ].e;
				if (cPos.jointPort==3)
				{
					InUpLeft=cPos.joint+CPoint(-rSIZE/2,0);
					InDownRight=cPos.A+CPoint(rSIZE/2,0);
				}
				if (cPos.jointPort==1)
				{
					InUpLeft=cPos.A+CPoint(0,-1);
					InDownRight=cPos.joint+CPoint(0,1);
				}
				if (cPos.jointPort==4)
				{
					InUpLeft=cPos.A;
					InDownRight=cPos.joint;
				}					
				OutUpLeft=cPos.B+CPoint(0,-rSIZE/2);
				OutDownRight=cPos.A+CPoint(0,rSIZE/2);
			} 
			if (cPos.cI==cPos.pI && cPos.cJ-cPos.pJ==1)
			{ 
				cPos.dir=4;			// southbound
				cPos.joint=cPos.B;
				cPos.A=Node[cPos.pI][cPos.pJ].s;
				cPos.B=Node[cPos.cI][cPos.cJ].n;
				if (cPos.jointPort==2)
				{
					InUpLeft=cPos.joint;
					InDownRight=cPos.A;
				}
				if (cPos.jointPort==1)
				{
					InUpLeft=cPos.A+CPoint(0,-rSIZE/2);
					InDownRight=cPos.joint+CPoint(0,rSIZE/2);
				}
				if (cPos.jointPort==3)
				{
					InUpLeft=cPos.joint+CPoint(-1,0);
					InDownRight=cPos.A+CPoint(1,0);
				}
				OutUpLeft=cPos.A+CPoint(-rSIZE/2,0);
				OutDownRight=cPos.B+CPoint(rSIZE/2,0);
			} 
			if (cPos.cI==cPos.pI && cPos.cJ-cPos.pJ==-1)
			{ 
				cPos.dir=3;			// northbound
				cPos.joint=cPos.B;
				cPos.A=Node[cPos.pI][cPos.pJ].n;
				cPos.B=Node[cPos.cI][cPos.cJ].s;
				if (cPos.jointPort==1)
				{
					InUpLeft=cPos.A;
					InDownRight=cPos.A+CPoint(rSIZE/2,rSIZE/2);
				}
				if (cPos.jointPort==4)
				{
					InUpLeft=cPos.A+CPoint(-1,0);
					InDownRight=cPos.A+CPoint(2,rSIZE);
				}
				if (cPos.jointPort==2)
				{
					InUpLeft=cPos.A+CPoint(-rSIZE/2,0);
					InDownRight=cPos.A+CPoint(0,rSIZE/2);
				}
				OutUpLeft=cPos.B+CPoint(-rSIZE/2,0);
				OutDownRight=cPos.A+CPoint(rSIZE/2,0);
			}				
			InsideRect=CRect(InUpLeft,InDownRight);			
			InvalidateRect(InsideRect);
			OutsideRect=CRect(OutUpLeft,OutDownRight);
			InvalidateRect(OutsideRect);
			
			int SumSquare=(cPos.cI-cPos.pI)*(cPos.cI-cPos.pI)
				+(cPos.cJ-cPos.pJ)*(cPos.cJ-cPos.pJ);
			if (SumSquare!=1)
			{
				cPos.status=0;
				BusColor++;
				if (BusColor==10)
					BusColor=0;
			}
		}
		if (!cPos.status)
		{
			cPos.pI=cPos.cI; i=cPos.pI;
			cPos.pJ=cPos.cJ; j=cPos.pJ;
			if (cPos.cI==1)	// starting from west
			{
				cPos.B=Node[i][j].w;
				cPos.A=cPos.B+CPoint(-10,0);
				OutUpLeft=Node[i][j].home+CPoint(-10,0);
				OutDownRight=Node[cPos.cI][cPos.cJ].home+CPoint(0,rSIZE);
			}
			if (cPos.cI==N)	// starting from east
			{
				cPos.B=Node[i][j].e;
				cPos.A=cPos.B+CPoint(10,0);
				OutUpLeft=Node[i][j].home+CPoint(rSIZE,0);
				OutDownRight=Node[i][j].home+CPoint(rSIZE+10,rSIZE);
			}
			if (cPos.cJ==1)	// starting from north
			{
				cPos.B=Node[i][j].n;
				cPos.A=cPos.B+CPoint(0,-10);
				OutUpLeft=Node[i][j].home+CPoint(0,-10);
				OutDownRight=Node[i][j].home+CPoint(rSIZE,0); 
			}
			if (cPos.cJ==M)	// starting from south
			{
				cPos.B=Node[i][j].s;
				cPos.A=cPos.B+CPoint(0,10);
				OutUpLeft=Node[i][j].home+CPoint(0,rSIZE);
				OutDownRight=Node[i][j].home+CPoint(rSIZE,rSIZE+10);
			}
			cPos.joint=cPos.B;
			OutsideRect=CRect(OutUpLeft,OutDownRight);
			InvalidateRect(OutsideRect);		
		}
	}
}
