// Code10B.cpp
#include "Code10B.h"

BEGIN_MESSAGE_MAP(CCode10B,CFrameWnd)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED (IDC_RESET,OnReset)
END_MESSAGE_MAP()

CCode10B::CCode10B()
{
	idc=600; m=24; eH=20;
	home=CPoint(30,250); end=CPoint(750,200);	
	eHome=CPoint(home.x,500); cHome=home;
	Create(NULL,L"Code10B: Single-row routing",WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
	bReset.Create(L"Reset",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 
		CRect(CPoint(end.x+100,60),CSize(120,30)),this,IDC_RESET);
	wInt=(end.x-home.x)/m;	
	fArial.CreatePointFont(60,L"Arial");
	fHelvetica.CreatePointFont(100,L"Helvetica");
	Initialize();
}

void CCode10B::OnPaint()
{
	CPaintDC dc(this);
	CString s;
	CRect rct;
	CPen pGray(PS_SOLID,1,RGB(200,200,200));
	CPen pDark(PS_SOLID,1,RGB(0,0,0));
	dc.SelectObject(pGray);
	for (int k=1;k<=m;k++)
	{
		dc.MoveTo(p[1].home.x,p[1].home.y+2);
		dc.LineTo(p[m].home.x,p[m].home.y+2);
	}
	dc.SelectObject(pDark); dc.SelectObject(fHelvetica); 
	dc.TextOutW(10,10,L"Click on the nodes from left to right for pairings");
	dc.SelectObject(fArial); 
	for (int k=1;k<=m;k++)
	{
		s.Format(L"%d",k);
		dc.Rectangle(p[k].cRct);
		dc.TextOutW(p[k].home.x+3,p[k].home.y-4,s);
	}
}

void CCode10B::OnReset()
{
	CClientDC dc(this);
	CBrush bClear(RGB(255,255,255));
	CRect rct;
	GetClientRect(rct);
	dc.FillRect(rct,&bClear);
	Initialize(); Invalidate();
}

void CCode10B::Initialize()
{
	for (int k=1;k<=m;k++)
	{
		p[k].home=CPoint(30+wInt*(k-1),home.y);
		p[k].rct=CRect(CPoint(p[k].home.x-2,p[k].home.y),CSize(5,5));
		p[k].cRct=CRect(p[k].home.x,p[k].home.y-8,p[k].home.x+16,p[k].home.y+8);
		p[k].DL[0]=0;	// #doglegs at pin k
		p[k].flag=0;
	}
	bFlag=0; nNets=0; Q=0; E=0; D=0;
}

void CCode10B::OnLButtonDown(UINT nFlags,CPoint pt)
{
	int tmp;
	for (int k=1;k<=m;k++)
		if (p[k].cRct.PtInRect(pt) && !p[k].flag)
		{
			bFlag++;
			if (bFlag==1)
			{
				nNets++;
				q[nNets].b=k;
				MarkPin(k);
			}
			if (bFlag==2)
			{
				q[nNets].e=k;
				if (q[nNets].e<q[nNets].b)
				{
					tmp=q[nNets].e;
					q[nNets].e=q[nNets].b;
					q[nNets].b=tmp;
				}
				UpdateEnergyBar();
				MarkPin(k);
				if (nNets==m/2)
					EnergyScheme();
				bFlag=0;
			}
		}
}

void CCode10B::UpdateEnergyBar()
{
	CClientDC dc(this);
	CString s;
	CRect rct;
	CBrush bRct(RGB(0,0,200));
	dc.SelectObject(fHelvetica);
	p[q[nNets].b].eHome=CPoint(p[q[nNets].b].home.x,eHome.y+eH*(nNets-1));
	p[q[nNets].e].eHome=CPoint(p[q[nNets].e].home.x,eHome.y+eH*(nNets-1));		
	q[nNets].order=nNets;	// order from top to bottom
	p[q[nNets].b].net=nNets; p[q[nNets].e].net=nNets;	// begin,end belongs to net
	dc.MoveTo(p[q[nNets].b].eHome); dc.LineTo(p[q[nNets].e].eHome);
	rct=CRect(p[q[nNets].b].eHome.x,p[q[nNets].b].eHome.y-2,p[q[nNets].b].eHome.x+4,p[q[nNets].b].eHome.y+2);
	dc.FillRect(rct,&bRct);
	rct=CRect(p[q[nNets].e].eHome.x,p[q[nNets].e].eHome.y-2,p[q[nNets].e].eHome.x+4,p[q[nNets].e].eHome.y+2);
	dc.FillRect(rct,&bRct);
	s.Format(L"%d: (%d,%d)",nNets,q[nNets].b,q[nNets].e);
	dc.TextOutW(end.x+100,250+20*(nNets-1),s);		
	dc.SelectObject(fArial);
	s.Format(L"%d",q[nNets].b);
	dc.TextOutW(p[q[nNets].b].home.x-10,eHome.y-10+eH*(nNets-1),s);
	s.Format(L"%d",q[nNets].e); 
	dc.TextOutW(p[q[nNets].e].home.x+5,eHome.y-10+eH*(nNets-1),s);
	dc.SelectObject(fHelvetica);
	s.Format(L"%d",nNets); 
	dc.TextOutW(5,p[q[nNets].b].eHome.y-10,s);
}

void CCode10B::EnergyScheme()
{
	CClientDC dc(this);
	CString s;
	CPen pBlue(PS_SOLID,1,RGB(0,0,200));
	CPen pDark(PS_SOLID,1,RGB(0,0,0));
	CBrush bClear(RGB(255,255,255));
	CRect rct;
	int i,j,k;
	int w,r,max;
	double tmp;
	dc.SelectObject(pBlue);
	dc.MoveTo(p[1].eHome);
	for (i=1;i<m;i++)
		 dc.LineTo(p[i+1].eHome);

	// Determine the doglegs of every net, partition every net into segments
	for (k=1;k<=nNets;k++)
	{
		q[k].nSeg=0;
		q[k].DL[0]=0; r=1; 
		q[k].DL[r]=q[k].e;
		q[k].Seg[r].b=q[k].b;
		for (j=q[k].b+1;j<q[k].e;j++)
			if ((q[k].order<q[p[j].net].order && q[k].order>q[p[j+1].net].order)
				|| (q[k].order>q[p[j].net].order && q[k].order<q[p[j+1].net].order))
			{
				q[k].DL[r]=j; q[k].DL[0]++; 
				w=++p[j].DL[0]; p[j].DL[w]=k;
				q[k].Seg[r].e=j+1; 
				q[k].nSeg++;
				r++;
				q[k].Seg[r].b=j;
			}
		q[k].Seg[r].e=q[k].e; q[k].nSeg++;
		D += q[k].DL[0];
	}
	// determine the energy of segment i of net k
	for (k=1;k<=nNets;k++)
		for (i=1;i<=q[k].nSeg;i++)
		{
			max=0;
			for (j=q[k].Seg[i].b+1;j<q[k].Seg[i].e;j++)
			{
				r=1;
				for (w=1;w<=nNets;w++)
					if (w!=k || w!=p[j].net)
						if (p[j].home.x>p[q[w].b].home.x && p[j].home.x<p[q[w].e].home.x)
							if ((q[w].order>q[k].order && q[w].order<q[p[j].net].order)
									|| (q[w].order<q[k].order && q[w].order>q[p[j].net].order))
								r++;
				max=((max<r)?r:max);
			}
			q[k].Seg[i].E=((q[k].order<q[p[q[k].Seg[i].b+1].net].order)?max:-max);
			q[k].Seg[i].sb.y=p[q[k].Seg[i].b].home.y-20*q[k].Seg[i].E;
			q[k].Seg[i].se.y=q[k].Seg[i].sb.y;
			E += abs(q[k].Seg[i].E);
			if (Q<abs(q[k].Seg[i].E))
				Q=abs(q[k].Seg[i].E);
		}
	// compute the dogleg coordinates, draw the nets
	dc.SelectObject(pDark);
	for (k=1;k<=nNets;k++)
		for (i=1;i<=q[k].nSeg;i++)
		{
			if (i==1)
			{
				q[k].Seg[i].sb.x=p[q[k].b].home.x;
				q[k].Seg[i].se.x=p[q[k].DL[i]].home.x;
				if (q[k].DL[i]<q[k].Seg[i].e)
				{
					tmp=(double)(p[q[k].DL[i]].home.x+(home.y-q[k].Seg[i].se.y)
						*(p[q[k].DL[i]+1].home.x-p[q[k].DL[i]].home.x)/(q[k].Seg[i+1].sb.y-q[k].Seg[i].se.y));
					q[k].Seg[i].se.x=(int)tmp;
				}
			}
			if (i>1 && i<q[k].nSeg)
			{
				q[k].Seg[i].sb.x=q[k].Seg[i-1].se.x;
				q[k].Seg[i].se.x=p[q[k].DL[i]].home.x;
				if (q[k].DL[i]<q[k].Seg[i].e)
				{
					tmp=(double)(p[q[k].DL[i]].home.x+(home.y-q[k].Seg[i].se.y)
						*(p[q[k].DL[i]+1].home.x-p[q[k].DL[i]].home.x)/(q[k].Seg[i+1].sb.y-q[k].Seg[i].se.y));
					q[k].Seg[i].se.x=(int)tmp;
				}
			}
			if (i==q[k].nSeg)
			{
				if (i>1)
				{
					q[k].Seg[i].sb.x=q[k].Seg[i-1].se.x;
					q[k].Seg[i].se.x=p[q[k].e].home.x;
				}
				dc.SelectObject(fHelvetica);
				s.Format(L"%d",k);
				dc.TextOutW(q[k].Seg[i].se.x+5,q[k].Seg[i].se.y-5,s);
			}
			dc.SelectObject(fArial); dc.SetTextColor(RGB(200,0,0));
			s.Format(L"%d",q[k].Seg[i].E);
			dc.TextOutW((q[k].Seg[i].sb.x+q[k].Seg[i].se.x)/2,eHome.y-10+eH*(k-1),s);
			dc.SetTextColor(RGB(0,0,0));
			dc.MoveTo(q[k].Seg[i].sb.x,home.y);
			dc.LineTo(q[k].Seg[i].sb); dc.LineTo(q[k].Seg[i].se);
			dc.LineTo(q[k].Seg[i].se.x,home.y);
		}
	rct=CRect(0,0,300,30);
	dc.FillRect(rct,&bClear);
	dc.SelectObject(fHelvetica);
	s.Format(L"E=%d, Q=%d, D=%d",E,Q,D);
	dc.TextOutW(20,10,s);
}

void CCode10B::MarkPin(int k)
{
	CClientDC dc(this);
	CString s;
	CBrush pClear(RGB(255,255,255)),bRct(RGB(0,0,200));
	dc.FillRect(p[k].cRct,&pClear);
	dc.FillRect(p[k].rct,&bRct);
	dc.SelectObject(fArial);
	s.Format(L"%d",k); 
	dc.TextOutW(p[k].home.x+5,p[k].home.y+3,s);
	p[k].flag=1;
}
