// Code10B.h
#include <afxwin.h>
#define M 24			// max #pins
#define IDC_RESET 301
using namespace std;

class CCode10B : public CFrameWnd
{
private:
	CPoint home,end;	// axis home,end
	CPoint cHome;		// click home
	CPoint eHome;		// energy diagram home
	int idc;
	int m;				// #pins
	int nNets;			// #selected nets
	int wInt;			// width of intervals in axis
	int eH;				// height of energy bars
	int bFlag;			// button flag
	int Q,D,E;			// Q=congestion, E=energy, D=doglegs
	CButton bReset,bChange,bOpenFile,bSaveFile,bAbout;
	CFont fArial,fHelvetica;
	
	typedef struct
	{
		int b,e;
		int E;
		CPoint sb,se;
	} SEGMENT;
		
	typedef struct
	{
		CPoint home;	// pin home at axis
		CPoint eHome;	// energy home
		CRect rct;		// pin box
		CRect cRct;		// click box
		int net;		// net where p belongs
		int DL[M+1];	// dogleg
		bool flag;
	} PIN;
	PIN p[M+1];

	typedef struct
	{
		int b,e;
		int E[M+1];
		int order;
		int DL[M+1];	// doglegs
		SEGMENT Seg[M+1];
		int nSeg;
	} NET;
	NET q[M+1];

public:
	CCode10B();
	~CCode10B()		{}
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT,CPoint);
	afx_msg void OnReset();
	void Initialize();
	void MarkPin(int);
	void EnergyScheme();
	void UpdateEnergyBar();
	DECLARE_MESSAGE_MAP()
};

class CMyWinApp : public CWinApp
{
public:
	virtual BOOL InitInstance();
}; 
CMyWinApp  MyApplication;

BOOL CMyWinApp::InitInstance()
{
	m_pMainWnd = new CCode10B;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	return TRUE;
}
