// Code2B.cpp
#include "Code2B.h"

BEGIN_MESSAGE_MAP(CCode2B,CFrameWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()

CCode2B::CCode2B()
{
	Create(NULL,L"Code2B: Drawing Graphics",
		WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
}

void CCode2B::OnPaint()
{
	CPaintDC dc(this);
	CRect rct;
	CPen pen1(PS_SOLID,2,RGB(200,0,0));		// red
	CPen pen2(PS_SOLID,1,RGB(150,0,255));	// purple
	CPen pen3(PS_SOLID,3,RGB(200,200,0));	// gold
	
	// drawing a line
	dc.SelectObject(pen3);
	dc.MoveTo(150,300);	dc.LineTo(50,500);

	// drawing a rectangle & ellipse
	dc.SelectObject(pen2);
	rct=CRect(50,60,200,160);
	dc.Rectangle(rct);
	rct=CRect(50,200,200,260);
	dc.Ellipse(rct);

	// drawing empty rectangles
	int i,j;
	int M=10,N=5,width=70,height=20;	
	CString s;
	CFont font;
	font.CreatePointFont(100,L"Helvetica");	
	CPoint home;	
	home=CPoint(300,50);
	dc.SelectObject(pen1);
	dc.SelectObject(font); dc.SetTextColor(RGB(0,0,200));
	for (i=1;i<=M;i++)			// i=row
	{
		// horizontal lines
		dc.MoveTo(home.x,home.y+height*(i-1));
		dc.LineTo(home.x+width*(N-1),home.y+height*(i-1));
		for (j=1;j<=N;j++)		// j=column
		{
			// vertical lines
			dc.MoveTo(home.x+width*(j-1),home.y);
			dc.LineTo(home.x+width*(j-1),home.y+height*(M-1));
			if (i<M && j<N)
			{
				// captions
				s.Format(L"%d,%d",i,j);
				dc.TextOut(home.x+20+width*(j-1),home.y
					+5+height*(i-1),s);
			}
		}
	}
	
	// drawing circles
	int radius;	
	CPoint center=CPoint(home.x+100,home.y+350);
	dc.SelectObject(pen2);
	for (i=10;i>=1;i--)
	{
		radius=20+15*(i-1);
		rct=CRect(CPoint(center.x-radius,center.y-radius),
			CSize(2*radius,2*radius));
		dc.Ellipse(rct);
	}
	
	// drawing solid rectangles		
	int color;
	width=40; height=10; M=25, N=5;
	for (i=1;i<=M;i++)
		for (j=1;j<=N;j++)
		{
			switch(j)
			{
			case 1:
				color=RGB(10*(i-1),10*(i-1),10*(i-1)); break;// bw monotone
			case 2:
				color=RGB(10*(i-1),0,0); break;		// red monotone
			case 3:
				color=RGB(0,10*(i-1),0); break;		// green monotone
			case 4:
				color=RGB(0,0,10*(i-1)); break;		// blue monotone
			case 5:
				color=RGB(10*(i-1),10*(i-1),0); break;	// yellow monotone
			}
			home=CPoint(650+(width+10)*(j-1),50+(height+5)*(i-1));	
			rct=CRect(CPoint(home),CSize(width,height));
			dc.FillSolidRect(rct,color);
		}
}
