// Code2C: Graph
#include "Code2C.h"

BEGIN_MESSAGE_MAP(CCode2C,CFrameWnd)
	ON_WM_PAINT()
	ON_BN_CLICKED (IDC_BUTTON1,OnCompute)
	ON_BN_CLICKED (IDC_BUTTON2,NewGraph)
END_MESSAGE_MAP()

CCode2C::CCode2C()
{
	CString s;
	home=CPoint(30,100); end=CPoint(500,700);	
	fArial.CreatePointFont(60,L"Arial");
	fHelvetica.CreatePointFont(100,L"Helvetica");
	Create(NULL,L"Graph",WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
	button1.Create(L"Draw Graph",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(30,30),CSize(180,40)),this,IDC_BUTTON1);
	eNodes.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(home.x+350,home.y-60),CSize(100,25)),this,401);
}

void CCode2C::OnCompute()
{	
	CString s;
	eNodes.GetWindowText(s); n=_ttoi(s);
	n=((n>N || n<=1)?N:n);
	Initialize();
}

void CCode2C::Initialize()
{	
	int i,j;
	double distance;
	button1.DestroyWindow(); button2.DestroyWindow();
	button2.Create(L"New Graph",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(30,30),CSize(180,40)),this,IDC_BUTTON2);
	srand(time(0));
	for (i=1;i<=n;i++)
	{
		v[i].home.x=home.x+20+rand()%(end.x-home.x-50);
		v[i].home.y=home.y+20+rand()%(end.y-home.y-50);
		v[i].rct=CRect(v[i].home.x,v[i].home.y,v[i].home.x+25,v[i].home.y+25);
	}	
	for (i=1;i<=n;i++)
	{
		v[i].wt[i]=0;
		for (j=i+1;j<=n;j++)
		{
			distance=sqrt(pow((double)(v[i].home.x-v[j].home.x),2)
							+pow((double)(v[i].home.y-v[j].home.y),2));
			if (distance<=LinkRange)
				v[i].wt[j]=1+rand()%9;
			else
				v[i].wt[j]=99;
			v[j].wt[i]=v[i].wt[j];
		}
	}
	Invalidate();
	ShowTable();
}

void CCode2C::OnPaint()
{	
	CPaintDC dc(this);
	CString s;
	CRect rct;
	CPen rPen(PS_SOLID,3,RGB(0,0,0));
	CPen mPen(PS_SOLID,2,RGB(0,0,0));
	CPen qPen(PS_SOLID,1,RGB(100,100,100));
	CPoint mPoint,pt;
	int i,j;
	dc.SelectObject(fHelvetica);
	dc.TextOutW(home.x+260,home.y-55,L"#Nodes (2-20)");
	dc.SelectObject(rPen);
	dc.Rectangle(home.x-10,home.y-10,end.x+10,end.y+10);
	dc.SelectObject(qPen); dc.SelectObject(fArial);
	for (i=1;i<=n;i++)
		for (j=1;j<=n;j++)
			if (v[i].wt[j]!=99)
			{
				dc.MoveTo(CPoint(v[i].home)); 
				dc.LineTo(CPoint(v[j].home));
				mPoint=CPoint((v[i].home.x+v[j].home.x)/2,
					(v[i].home.y+v[j].home.y)/2);
				s.Format(L"%d",v[i].wt[j]);
				dc.TextOut(mPoint.x,mPoint.y,s);
			}
	for (i=1;i<=n;i++)
		DrawNode(i);
}

void CCode2C::DrawNode(int u)
{	
	CClientDC dc(this);
	CString s;
	CPoint pt;
	CPen pBlack(PS_SOLID,2,RGB(0,0,0));
	dc.SelectObject(pBlack);
	pt=v[u].home;
	dc.Rectangle(v[u].rct);
	s.Format(L"%d",u); dc.TextOut(pt.x+5,pt.y+5,s);
}

void CCode2C::ShowTable()
{
	CString s;
	int i,j;
	table.DestroyWindow();
	CRect rct=CRect(CPoint(end.x+30,home.y+20),CSize(400,370));

	// creates the list view window
   	table.Create(WS_VISIBLE | WS_CHILD | WS_DLGFRAME | LVS_REPORT
       		 | LVS_NOSORTHEADER,rct,this,802);
	for (j=0;j<=n;j++)
	{
		s.Format((j==0)?L"wt":L"%d",j);
		table.InsertColumn(j,s,LVCFMT_CENTER,30);
	}
	for (i=1;i<=n;i++)
	{
		s.Format(L"%d",i); 
		table.InsertItem(i-1,s,0);
		for (j=1;j<=n;j++)
		{
			s.Format(L"%d",v[i].wt[j]); table.SetItemText(i-1,j,s);
		}
	}
}

void CCode2C::NewGraph()
{
	Initialize(); Invalidate();
}