#include "Code2D.h"
#define PI 3.142
#define L (double)1.0

BEGIN_MESSAGE_MAP(CCode2D,CFrameWnd)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_COMPUTE,OnCompute)
END_MESSAGE_MAP()

CCode2D::CCode2D()
{
	idc=400;
	Create(NULL,L"Hexagon",WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
	home=CPoint(20,50); end=CPoint(600,500);
	CHome.x=-2; CEnd.x=10; CHome.y=2; CEnd.y=-10;
	eR.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(home.x+30,home.y-10),CSize(100,25)),this,idc++);
	eC.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(home.x+150,home.y-10),CSize(100,25)),this,idc++);
	bCompute.Create(L"Compute",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(home.x+270,home.y-10),CSize(180,25)),this,IDC_COMPUTE);
	fArial.CreatePointFont(60,L"arial");
	fHelvetica.CreatePointFont(100,L"Helvetica");
}

void CCode2D::OnPaint()
{
	CPaintDC dc(this);
	dc.SelectObject(fHelvetica);
	dc.TextOutW(home.x+30,home.y-35,L"#rows (2-10)");
	dc.TextOutW(home.x+150,home.y-35,L"#columns (2-10)");
}

void CCode2D::OnCompute()
{
	CString s;
	eR.GetWindowText(s); m=_ttoi(s);
	if (m>10)
		m=10;
	eC.GetWindowText(s); n=_ttoi(s);
	if (n>10)
		n=10;
	if (m%2==0)
		m--;
	Initialize();
	DrawHex();
}

void CCode2D::Initialize()
{
	int i,j,k,r;
	h[1][1].a.x=0; h[1][1].a.y=0;
	for (i=1;i<=m;i++)			// i=row, j=column
		for (j=1;j<=n;j++)
		{
			if (i%2==1)
			{
				h[i][j].a.x=h[1][1].a.x+2*L*cos(PI/6)*(j-1);
				h[i][j].a.y=h[1][1].a.y-(2*L+2*L*sin(PI/6))*(i-1)/2;
			}
			else
				if (j<n)
				{
					h[i][j].a.x=h[1][1].a.x+L*cos(PI/6)+2*L*cos(PI/6)*(j-1);
					h[i][j].a.y=(h[1][1].a.y-L-L*sin(PI/6))-(2*L+2*L*sin(PI/6))*((i-1)/2);
				}
			h[i][j].b.x=h[i][j].a.x+L*cos(PI/6); h[i][j].b.y=h[i][j].a.y-L*sin(PI/6);
			h[i][j].c.x=h[i][j].b.x; h[i][j].c.y=h[i][j].a.y-L*sin(PI/6)-L;
			h[i][j].d.x=h[i][j].a.x; h[i][j].d.y=h[i][j].a.y-2*L*sin(PI/6)-L;
			h[i][j].e.x=h[i][j].a.x-L*cos(PI/6); h[i][j].e.y=h[i][j].c.y;
			h[i][j].f.x=h[i][j].e.x; h[i][j].f.y=h[i][j].b.y;
		}	
		
	k=1;
	for (j=1;j<=n;j++)
	{
		for (i=1;i<=m;i++)
			if (i%2==1)
			{
				if (j==1)		// first column (f,e,a,d) and last columns (b,c) 
				{
					r=k+(j-1)*(m+1); 
					h[i][j].f.p=r; v[r].home=h[i][j].f;

					r++;
					h[i][j].e.p=r; v[r].home=h[i][j].e;

					r=k+(j+1)*(m+1);
					h[i][j].a.p=r; v[r].home=h[i][j].a; 

					r++;
					h[i][j].d.p=r; v[r].home=h[i][j].d;
					h[i+1][j].f.p=h[i][j].d.p;

					r=k+j*(m+1);
					h[i][n].b.p=r; v[r].home=h[i][n].b; 

					r++;
					h[i][n].c.p=r; v[r].home=h[i][n].c; 
					k+=2;
				}
				if (j>1)		// intermediate columns (b,c,a,d)
				{
					if (j==2 && i==1)
						k=1;
					r=k+(j+1)*(m+1); h[i][j].f.p=r; h[i][j-1].b.p=h[i][j].f.p;
					v[r].home=h[i][j].f; 

					r++;
					h[i][j].e.p=r; v[r].home=h[i][j].e; h[i][j-1].c.p=h[i][j].e.p;

					r=k+(j+2)*(m+1); h[i][j].a.p=r;
					v[r].home=h[i][j].a; 

					r++;
					h[i][j].d.p=r; v[r].home=h[i][j].d;

					k+=2;
				}
			}
	}
	
	for (i=1;i<=m;i+=2)
		for (j=1;j<=n-1;j++)
		{
			h[i][j].b.p=h[i][j+1].f.p;
			h[i][j].c.p=h[i][j+1].e.p;
		}
	for (i=2;i<=m-1;i+=2)
		for (j=1;j<=n-1;j++)
		{
			h[i][j].f.p=h[i-1][j].d.p;
			h[i][j].e.p=h[i+1][j].a.p;
			h[i][j].a.p=h[i-1][j].c.p;
			h[i][j].d.p=h[i+1][j].b.p;
			h[i][j].b.p=h[i-1][j+1].d.p;
			h[i][j].c.p=h[i+1][j+1].a.p;
		}
	int u[7],ii,jj;
	for (i=1;i<=m;i++)
		for (j=1;j<=n;j++)
		{
			u[1]=h[i][j].a.p; u[2]=h[i][j].b.p; u[3]=h[i][j].c.p;
			u[4]=h[i][j].d.p; u[5]=h[i][j].e.p;	u[6]=h[i][j].f.p;
			if (i%2==1 || (i%2==0 && j<n))
				for (ii=1;ii<=6;ii++)
					for (jj=1;jj<=6;jj++)
					{
						v[u[ii]].C[u[jj]]=0;
						if (ii!=jj)
							v[u[ii]].C[u[jj]]=1;
					}
		}
}

void CCode2D::DrawHex()
{
	CClientDC dc(this);	
	CPoint Q;
	CString s;
	int i,j,k,r;
	CPen pBlue(PS_SOLID,1,RGB(0,0,255));
	CPen pBlack(PS_SOLID,1,RGB(0,0,0));
	CPen pRed(PS_SOLID,1,RGB(255,0,0));

	dc.SelectObject(fHelvetica);
	s.Format(L"Size of Grid: %d x %d",m,n);
	dc.TextOutW(end.x,home.y-10,s);
	dc.SelectObject(fArial);dc.SelectObject(pBlue);
	for (i=1;i<=m;i++)
		for (j=1;j<=n;j++)
		{
			Q=ConvertCW(h[i][j].a); dc.MoveTo(Q);
			Q=ConvertCW(h[i][j].b); dc.LineTo(Q);
			Q=ConvertCW(h[i][j].c); dc.LineTo(Q);
			Q=ConvertCW(h[i][j].d); dc.LineTo(Q);
			Q=ConvertCW(h[i][j].e); dc.LineTo(Q);
			Q=ConvertCW(h[i][j].f);	dc.LineTo(Q);
			Q=ConvertCW(h[i][j].a); dc.LineTo(Q);
		}
	k=1;
	for (j=1;j<=n;j++)
	{
		for (i=1;i<=m;i++)
			if (i%2==1)
			{
				if (j==1)	// first column (f,e,a,d),last columns (b,c) 
				{
					r=k+(j-1)*(m+1); DrawNode(r);
					r++; DrawNode(r);
					r=k+(j+1)*(m+1); DrawNode(r);
					r++; DrawNode(r);
					r=k+j*(m+1); DrawNode(r);
					r++; DrawNode(r);			
					k+=2;
				}
				if (j>1)	// intermediate columns (b,c,a,d)
				{
					if (j==2 && i==1)
						k=1;
					r=k+(j+1)*(m+1); DrawNode(r);
					r++; DrawNode(r);
					r=k+(j+2)*(m+1); DrawNode(r);
					r++; DrawNode(r);
					k+=2;
				}
			}
	}	
}

void CCode2D::DrawNode(int u)
{	
	CClientDC dc(this);
	CString s;
	CPoint pt;
	CRect rct;
	CPen pBlack(PS_SOLID,1,RGB(0,0,0));
	dc.SelectObject(fArial); dc.SelectObject(pBlack);
	pt=ConvertCW(v[u].home);
	rct=CRect(pt.x-7,pt.y-7,pt.x+10,pt.y+7);
	dc.Rectangle(rct);
	s.Format(L"%d",u); dc.TextOut(pt.x-5,pt.y-5,s);
}

CPoint CCode2D::ConvertCW(PT p)		// converts C to W
{
	CPoint px;
	double m1,c1,m2,c2;
	m1=(double)(end.x-home.x)/(CEnd.x-CHome.x);	
	c1=(double)(home.x-CHome.x*m1);
	m2=(double)(end.y-home.y)/(CEnd.y-CHome.y);	
	c2=(double)(home.y-CHome.y*m2);
	px.x=p.x*m1+c1; px.y=p.y*m2+c2;
	return px;
}
