// Code3A.cpp
#include "Code3A.h"

BEGIN_MESSAGE_MAP(CCode3A,CFrameWnd)
	ON_BN_CLICKED (IDC_BUTTON,OnCompute)
END_MESSAGE_MAP()

CCode3A::CCode3A()
{
	int i,j;
	idc=200; n=0;
	Create(NULL,L"Power Method",WS_OVERLAPPEDWINDOW,CRect(0,0,1000,900));
	button.Create(L"Compute",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(20,50),CSize(180,40)),this,IDC_BUTTON);
	for (i=1;i<=N;i++)
	{
		for (j=1;j<=N;j++)
			eA[j][i].Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
				CRect(CPoint(20+55*(j-1),220+40*(i-1)),CSize(40,25)),this,idc++);
		eV[i].Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
			CRect(CPoint(70+50*(i-1),110),CSize(35,25)),this,idc++);
	}
	eEpsilon.Create(WS_CHILD | WS_VISIBLE |WS_BORDER | SS_CENTER, 
		CRect(CPoint(90,155),CSize(50,25)),this,idc++);
	sLabel1.Create(L"Epsilon", WS_VISIBLE | SS_CENTERIMAGE | SS_CENTER,
		CRect(CPoint(20,155),CSize(60,30)),this,IDC_STATIC);
	sLabel2.Create(L"v(0)", WS_VISIBLE | SS_CENTERIMAGE | SS_CENTER,
		CRect(CPoint(20,110),CSize(40,30)),this,IDC_STATIC);
}

afx_msg void CCode3A::OnCompute()
{
	int i,j;
	CString s;
	bool flag=0;
	for (i=1;i<=N;i++)
	{
		for (j=1;j<=N;j++)
		{
			eA[j][i].GetWindowTextW(s); A[i][j]=_tstof(s);
			if (i==j && s=="")
			{
				flag=1; break;
			}
		}
		eV[i].GetWindowTextW(s); Eigen[0].v[i]=_tstof(s);
		if (flag)
		{
			n=i-1; break;
		}
	}
	eEpsilon.GetWindowTextW(s); Epsilon=_tstof(s);
	PowerMtd();
}

void CCode3A::PowerMtd()
{
	int k,m=0;
	double error[M+1];
	for (k=0;k<M;k++)
	{
		Multiply(k);
		if (k>0)
		{
			error[k]=fabs(Eigen[k+1].lambda-Eigen[k].lambda);
			if (error[k]<Epsilon)
			{
				ShowTable(error,m);
				break;		
			}
		}
		m++;
	}
}

void CCode3A::Multiply(int k)
{
	int i,j;
	double max,w[N+1];
 	for (i=1; i<=n; i++)
   	{
		w[i]=0;
		for (j=1;j<=n;j++)
    		w[i] += A[i][j]*Eigen[k].v[j];
	}
	max=w[1];
	for (i=1;i<=n;i++)
		if (fabs(max)<fabs(w[i]))
			max=w[i];
	Eigen[k+1].lambda=max;
	for (i=1;i<=n;i++)
		Eigen[k+1].v[i]=w[i]/Eigen[k+1].lambda;
}

void CCode3A::ShowTable(double error[M+1],int m)
{
	CClientDC dc(this);
	CString s;
	CString S[]={"","v[1]","v[2]","v[3","v[4]","v[5]","v[6]","v[7]","v[8]"};
	int i,k;
	CRect rcTable=CRect(600,50,960,500);
	table.DestroyWindow();

	// creates the list view window
   	table.Create(WS_VISIBLE | WS_CHILD | WS_DLGFRAME | LVS_REPORT
       		 | LVS_NOSORTHEADER,rcTable,this,idc++);	
	table.InsertColumn(0,L"i",LVCFMT_CENTER,25);
	table.InsertColumn(1,L"Error",LVCFMT_CENTER,70);
	table.InsertColumn(2,L"Lambda",LVCFMT_CENTER,70);
	for (i=1;i<=n;i++)
	{
		table.InsertColumn(i+2,S[i],LVCFMT_CENTER,70);
	}

	for (k=0;k<=m+1;k++)
	{
		s.Format(L"%d",k); table.InsertItem(k,s,0);
		if (k>0)
		{			
			s.Format(L"%lf",Eigen[k].lambda); table.SetItemText(k,2,s);
			if (k<m+1)
			{
				s.Format(L"%lf",error[k]); table.SetItemText(k,1,s);
			}
			if (k==m+1)
			{	
				s.Format(L"Final Solution Lambda=%.6lf",Eigen[k].lambda); 
				dc.TextOutW(600,525,s);
			}
		}
		for (i=1;i<=n;i++)
		{
			s.Format(L"%lf",Eigen[k].v[i]); table.SetItemText(k,i+2,s);
		}
	}
}
