// Code3B.cpp
#include "Code3B.h"

BEGIN_MESSAGE_MAP(CCode3B, CFrameWnd)
    ON_WM_PAINT()
	ON_BN_CLICKED(IDC_NGRAPH,OnNewGraph)
	ON_BN_CLICKED(IDC_COMPUTE,OnCompute)
END_MESSAGE_MAP()

CCode3B::CCode3B()
{
	CPoint bHome=CPoint(30,20);
	idc=800;
	home=CPoint(30,140); end=CPoint(500,740);
	Create(NULL, L"Vertex coloring: Greedy algorithm",
		WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
	bNGraph.Create(L"New Graph",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(bHome),CSize(180,40)),this,IDC_NGRAPH);
	bCompute.Create(L"Assign Colors",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(bHome.x,bHome.y+50),CSize(180,40)),this,IDC_COMPUTE);
	sN.Create(L"#Nodes (5-20) ", WS_VISIBLE | SS_CENTERIMAGE | SS_RIGHT,
		CRect(CPoint(bHome.x+200,bHome.y),CSize(200,30)),this,IDC_STATIC);
	eN.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(bHome.x+410,bHome.y),CSize(50,30)),this,idc++);
	sAdj.Create(L"Adjacency Range (D:250) ", WS_VISIBLE | SS_CENTERIMAGE | SS_RIGHT,
		CRect(CPoint(bHome.x+200,bHome.y+35),CSize(200,30)),this,IDC_STATIC);
	eAdj.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(bHome.x+410,bHome.y+35),CSize(50,30)),this,idc++);
	fArial10.CreatePointFont(100,L"Arial"); 
	fArial8.CreatePointFont(80,L"Arial");
	int color[]={RGB(150,150,150),
		RGB(0,0,0),RGB(0,0,200),
		RGB(200,0,0),RGB(0,200,0),
		RGB(200,200,0),RGB(0,200,200),
		RGB(200,0,200),RGB(200,50,150),
		RGB(100,100,255),RGB(250,50,255),
		RGB(100,200,50),RGB(250,50,0),
		RGB(0,50,250),RGB(100,100,255),
		RGB(250,0,50),RGB(50,250,0),
		RGB(50,0,250),RGB(0,250,50),
		RGB(255,100,100),RGB(100,255,100)};
	for (int i=0;i<=N;i++)
		if (i==0)
			pColor[i].CreatePen(PS_SOLID,1,color[i]);
		else
			pColor[i].CreatePen(PS_SOLID,2,color[i]);	
	Initialize();
}

void CCode3B::Initialize()
{
	int i,j;
	double distance;
	CString s;
	s=""; eN.GetWindowText(s); n=_ttoi(s); n=((n<=N)?n:N);
	s=""; eAdj.GetWindowText(s); adjRange=_ttoi(s); 
	adjRange=((adjRange==0)?250:adjRange);
	srand(time(0));
	for (i=1;i<=n;i++)
	{
		v[i].home.x=home.x+20+rand()%(end.x-home.x-50);
		v[i].home.y=home.y+20+rand()%(end.y-home.y-50);
		v[i].rct=CRect(CPoint(v[i].home.x-10,v[i].home.y-10),CSize(25,25));
	}	
	for (i=1;i<=n;i++)
	{
		v[i].adj[i]=0;
		for (j=i+1;j<=N;j++)
		{		
			distance=sqrt(pow(double(v[i].home.x-v[j].home.x),2)
				+pow(double(v[i].home.y-v[j].home.y),2));
			v[i].adj[j]=((distance<=adjRange)?1:0);
			v[j].adj[i]=v[i].adj[j];
		}
	}
}

void CCode3B::OnPaint()
{
	CPaintDC dc(this);
	CString s;
	int i,j;
	dc.SelectObject(pColor[1]);
	dc.Rectangle(home.x-10,home.y-10,end.x+10,end.y+10);
	dc.SelectObject(pColor[0]);
	for (i=1;i<=n;i++)
		for (j=1;j<=n;j++)
			if (v[i].adj[j])
			{
				dc.MoveTo(CPoint(v[i].home)); 
				dc.LineTo(CPoint(v[j].home));
			}
	dc.SelectObject(fArial10); dc.SelectObject(pColor[1]);
	for (i=1;i<=n;i++)
	{
		dc.Rectangle(v[i].rct);
		s.Format(L"%d",i); 
		dc.TextOutW(v[i].home.x-5,v[i].home.y-5,s);
	}
}

void CCode3B::OnNewGraph()
{
	Initialize(); Invalidate();
}

void CCode3B::OnCompute()
{
	int i,j,k;
	for (k=1;k<=n;k++)
	{
		vColor[k]=0; v[k].color=0;
	}
	for (i=1;i<=n;i++)
	{	 
		k=1;
		if (i==1)
			kMax=k;
		else
			for (j=1;j<=n;j++)
				if (v[i].adj[j])
					if (k==v[j].color)
						k++;
		v[i].color=k; vColor[k]++;
		if (kMax<k)
			kMax=k;
		NodeUpdate(i);
	}
	ShowTable();
}

void CCode3B::NodeUpdate(int i)
{
	CClientDC dc(this);
	CRect rct;
	CString s;
	int k=v[i].color;
	dc.SelectObject(pColor[k]);
	dc.Rectangle(v[i].rct);
	s.Format(L"%d",i);				// display nodes in graph

	// display color info
	dc.TextOutW(v[i].home.x-5,v[i].home.y-5,s);
	rct=CRect(CPoint(end.x+30,home.y+25*k),CSize(20,20));
	dc.Rectangle(rct);
	dc.SelectObject(fArial8);
	s.Format(L"%d",k);		// display channel number in rct
	dc.TextOutW(end.x+35,home.y+3+25*k,s);
	s.Format(L"%d",i);		// display nodes for given channel
	dc.TextOutW(end.x+35+30*vColor[k],home.y+3+25*k,s);
	s.Format(L"# Colors = %d",kMax); 
	dc.TextOutW(end.x+30,home.y-3,s);
}

void CCode3B::ShowTable()
{
	CString s;
	int i,j;
	CRect rct;
	table.DestroyWindow();

	// creates the list view window
	rct=CRect(CPoint(end.x+220,home.y-10),CSize(250,300));
   	table.Create(WS_VISIBLE | WS_CHILD | WS_DLGFRAME | LVS_REPORT
       		 | LVS_NOSORTHEADER,rct,this,idc++);
	rct=CRect(CPoint(end.x+220,home.y+300),CSize(250,300));

	for (j=0;j<=n;j++)
	{
		s.Format((j==0)?L"adj":L"%d",j);
		table.InsertColumn(j,s,LVCFMT_CENTER,((j==0)?35:30));
	}
	for (i=1;i<=n;i++)
	{
		s.Format(L"%d",i); table.InsertItem(i-1,s,0);
		for (j=1;j<=n;j++)
		{
			s.Format(L"%d",v[i].adj[j]); table.SetItemText(i-1,j,s);
		}
	}	
}
