// Code3C.cpp
#include "Code3C.h"

BEGIN_MESSAGE_MAP(CCode3C,CFrameWnd)
	ON_WM_PAINT()
	ON_BN_CLICKED (IDC_NGRAPH,OnNewGraph)
	ON_BN_CLICKED (IDC_COMPUTE,OnCompute)
END_MESSAGE_MAP()

CCode3C::CCode3C()
{
	CPoint bhome=CPoint(30,20);
	idc=800;
	home=CPoint(30,140); end=CPoint(500,740);
	Create(NULL,L"Wireless mesh network: one channel per node",
		WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
	bNGraph.Create(L"New Graph",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(bhome),CSize(180,40)),this,IDC_NGRAPH);
	bCompute.Create(L"Assign Channels",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(bhome.x,bhome.y+50),CSize(180,40)),this,IDC_COMPUTE);
	sN.Create(L"#Nodes (5-20) ", WS_VISIBLE | SS_CENTERIMAGE | SS_RIGHT,
		CRect(CPoint(bhome.x+200,bhome.y),CSize(200,30)),this,IDC_STATIC);
	eN.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER,
		CRect(CPoint(bhome.x+410,bhome.y),CSize(50,30)),this,idc++);
	sAdj.Create(L"Adjacency Range (D:250) ", WS_VISIBLE | SS_CENTERIMAGE | SS_RIGHT,
		CRect(CPoint(bhome.x+200,bhome.y+35),CSize(200,30)),this,IDC_STATIC);
	eAdj.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(bhome.x+410,bhome.y+35),CSize(50,30)),this,idc++);
	sCoc.Create(L"Co-channel Range (D:0) ", WS_VISIBLE | SS_CENTERIMAGE | SS_RIGHT,
		CRect(CPoint(bhome.x+200,bhome.y+70),CSize(200,30)),this,IDC_STATIC);
	eCoc.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(bhome.x+410,bhome.y+70),CSize(50,30)),this,idc++);
	fArial10.CreatePointFont(100,L"Arial"); 
	fArial8.CreatePointFont(80,L"Arial");
	int Color[]={RGB(150,150,150),
		RGB(0,0,0),RGB(0,0,200),
		RGB(200,0,0),RGB(0,200,0),
		RGB(200,200,0),RGB(0,200,200),
		RGB(200,0,200),RGB(200,50,150),
		RGB(100,100,255),RGB(250,50,255),
		RGB(100,200,50),RGB(250,50,0),
		RGB(0,50,250),RGB(100,100,255),
		RGB(250,0,50),RGB(50,250,0),
		RGB(50,0,250),RGB(0,250,50),
		RGB(255,100,100),RGB(100,255,100)};
	for (int i=0;i<=N;i++)
		if (i==0)
			pColor[i].CreatePen(PS_SOLID,1,Color[i]);
		else
			pColor[i].CreatePen(PS_SOLID,2,Color[i]);
	Initialize();
}

afx_msg void CCode3C::OnNewGraph()
{
	Initialize(); Invalidate();
}

void CCode3C::Initialize()
{
	int i,j;
	double distance;
	CString s;
	s=""; eN.GetWindowText(s); n=_ttoi(s); n=((n<=N)?n:N);
	s=""; eAdj.GetWindowText(s); adjRange=_ttoi(s); adjRange=((adjRange==0)?250:adjRange);
	s=""; eCoc.GetWindowText(s); cocRange=_ttoi(s); cocRange=((cocRange==0)?0:cocRange);
	srand(time(0));
	for (i=1;i<=n;i++)
	{
		v[i].home.x=home.x+20+rand()%(end.x-home.x-50);
		v[i].home.y=home.y+20+rand()%(end.y-home.y-50);
		v[i].rct=CRect(CPoint(v[i].home.x-10,v[i].home.y-10),CSize(25,25));
		v[i].channel=0;	// initialize the cells with channel 0
	}
	for (i=1;i<=n;i++)
	{
		v[i].adj[i]=0; v[i].coc[i]=0;
		for (j=i+1;j<=n;j++)
		{
			distance=sqrt(pow((double)(v[i].home.x-v[j].home.x),2)
				+pow((double)(v[i].home.y-v[j].home.y),2));
			
			v[i].adj[j]=((distance<=adjRange)?1:0);
			v[j].adj[i]=v[i].adj[j];
			v[i].coc[j]=((distance>=cocRange)?0:1);
			v[j].coc[i]=v[i].coc[j];
		}
	}
}

afx_msg void CCode3C::OnPaint()
{
	CPaintDC dc(this);
	CString s;
	int i,j;
	dc.SelectObject(pColor[1]);
	dc.Rectangle(home.x-10,home.y-10,end.x+10,end.y+10);
	dc.SelectObject(pColor[0]);
	for (i=1;i<=n;i++)
		for (j=1;j<=n;j++)
			if (v[i].adj[j])
			{
				dc.MoveTo(CPoint(v[i].home)); 
				dc.LineTo(CPoint(v[j].home));
			}
	dc.SelectObject(fArial10); dc.SelectObject(pColor[1]);
	for (i=1;i<=n;i++)
	{
		dc.Rectangle(v[i].rct);
		s.Format(L"%d",i); 
		dc.TextOutW(v[i].home.x-5,v[i].home.y-5,s);
	}
}

void CCode3C::OnCompute()
{
	int i,j,k,r,cMax;
	bool w[N+1];
	
	// assign the channels
	kMax=0;
	for (k=1;k<=n;k++)
		vChannel[k]=0;
	for (i=1;i<=n;i++)
	{
		if (i==1)
		{
			v[i].channel=1; 
			k=1; vChannel[k]=0;
		}
		else
			while (k<=n)
			{
				w[k]=0;
				for (j=1;j<=i-1;j++)
					if (v[i].adj[j] && abs(k-v[j].channel)<1)	// adjacency
					{
						v[i].channel=k+1;
						w[k]=1;
					}
				if (!w[k])
				{
					r=0;
					for (j=1;j<=i-1;j++)
					{
						v[i].channel=k;
						if ((v[i].channel==v[j].channel)  && v[i].coc[j])	// co-channel
						{
							v[i].channel=k+1;
							r++;
						}
					}
					if (r==0)
						break;
				}
				k++;
			}
		vChannel[k]++;
		if (kMax<k)
			kMax=k;
		NodeUpdate(i);
	}
	ShowTable();
}

void CCode3C::NodeUpdate(int i)
{
	CClientDC dc(this);
	CRect rct;
	CString s;
	dc.SelectObject(pColor[v[i].channel]);
	dc.Rectangle(v[i].rct);
	s.Format(L"%d",i);				// display nodes in graph

	// display color info
	dc.TextOutW(v[i].home.x-5,v[i].home.y-5,s);
	rct=CRect(CPoint(end.x+30,home.y+25*v[i].channel),CSize(20,20));
	dc.Rectangle(rct);
	dc.SelectObject(fArial8);
	s.Format(L"%d",v[i].channel);	// display channel number in rct
	dc.TextOutW(end.x+35,home.y+3+25*v[i].channel,s);
	s.Format(L"%d",i);				// display nodes for given channel
	dc.TextOutW(end.x+35+30*vChannel[v[i].channel],home.y+3+25*v[i].channel,s);
	s.Format(L"# Colors = %d",kMax); dc.TextOutW(end.x+30,home.y-3,s);
}

void CCode3C::ShowTable()
{
	CString s;
	int i,j;
	cocTable.DestroyWindow(); adjTable.DestroyWindow();
	CRect rct;

	// creates the list view window
	rct=CRect(CPoint(end.x+220,home.y-10),CSize(250,300));
   	adjTable.Create(WS_VISIBLE | WS_CHILD | WS_DLGFRAME | LVS_REPORT
       		 | LVS_NOSORTHEADER,rct,this,idc++);
	rct=CRect(CPoint(end.x+220,home.y+300),CSize(250,300));
   	cocTable.Create(WS_VISIBLE | WS_CHILD | WS_DLGFRAME | LVS_REPORT
       		 | LVS_NOSORTHEADER,rct,this,idc++);
	for (j=0;j<=n;j++)
	{
		s.Format((j==0)?L"Adj":L"%d",j);
		adjTable.InsertColumn(j,s,LVCFMT_CENTER,((j==0)?35:30));
		s.Format((j==0)?L"Coc":L"%d",j);
		cocTable.InsertColumn(j,s,LVCFMT_CENTER,((j==0)?35:30));
	}
	for (i=1;i<=n;i++)
	{
		s.Format(L"%d",i); adjTable.InsertItem(i-1,s,0);
		s.Format(L"%d",i); cocTable.InsertItem(i-1,s,0);
		for (j=1;j<=n;j++)
		{
			s.Format(L"%d",v[i].adj[j]); adjTable.SetItemText(i-1,j,s);
			s.Format(L"%d",v[i].coc[j]); cocTable.SetItemText(i-1,j,s);
		}
	}	
}
