// Code4A.cpp
#include "Code4A.h"

BEGIN_MESSAGE_MAP(CCode4A, CFrameWnd)
    ON_WM_PAINT()
	ON_BN_CLICKED(IDC_NGRAPH,OnNewGraph)
	ON_BN_CLICKED(IDC_COMPUTE,OnCompute)
END_MESSAGE_MAP()

CCode4A::CCode4A()
{	
	idc=800;
	home=CPoint(30,100); end=CPoint(500,700);
	Create(NULL, L"Dijkstra's Shortest Path Solution",
		WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
	bNGraph.Create(L"New Graph",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(30,30),CSize(180,40)),this,IDC_NGRAPH);
	Initialize();	
	fArial.CreatePointFont(60,L"Arial"); 
	fHelvetica.CreatePointFont(100,L"Helvetica");
}

void CCode4A::Initialize()
{
	int i,j,k;
	double distance;
	eSv.DestroyWindow(); eDv.DestroyWindow(); bCompute.DestroyWindow();
	bCompute.Create(L"Compute SP",WS_CHILD | WS_VISIBLE 
		| BS_DEFPUSHBUTTON,CRect(CPoint(end.x-50,30),CSize(180,40)),
		this,IDC_COMPUTE);
	eSv.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
        CRect(CPoint(home.x+350,20),CSize(50,25)),this,idc++);
	eDv.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
        CRect(CPoint(home.x+350,50),CSize(50,25)),this,idc++);

	srand(time(0));
	for (i=1;i<=N;i++)
	{
		v[i].home.x=home.x+20+rand()%(end.x-home.x-50);
		v[i].home.y=home.y+20+rand()%(end.y-home.y-50);
		v[i].rct=CRect(v[i].home.x,v[i].home.y,v[i].home.x+25,v[i].home.y+25);
	}	
	for (i=1;i<=N;i++)
	{
		v[i].wt[i]=0;
		for (j=i+1;j<=N;j++)
		{
			distance=sqrt(pow((double)(v[i].home.x-v[j].home.x),2)
							+pow((double)(v[i].home.y-v[j].home.y),2));
			if (distance<=LinkRange)
				v[i].wt[j]=1+rand()%9;
			else
				v[i].wt[j]=99;
			v[j].wt[i]=v[i].wt[j];
		}
	}
	Sv=0; Dv=0;
}

void CCode4A::DrawNode(int u)
{	
	CClientDC dc(this);
	CString s;
	CPoint pt;
	CPen pBlack(PS_SOLID,2,RGB(0,0,0));
	CPen pRed(PS_SOLID,3,RGB(200,0,0));
	if (u==Sv || u==Dv)
		dc.SelectObject(pRed);
	else
		dc.SelectObject(pBlack);
	pt=v[u].home;
	dc.Rectangle(v[u].rct);
	s.Format(L"%d",u); dc.TextOut(pt.x+5,pt.y+5,s);
}

void CCode4A::OnPaint()
{
	CPaintDC dc(this);
	CString s;
	CRect rct;
	CPen rPen(PS_SOLID,3,RGB(0,0,0));
	CPen mPen(PS_SOLID,2,RGB(0,0,0));
	CPen qPen(PS_SOLID,1,RGB(100,100,100));
	CPoint mPoint,pt;
	int i,j;
	dc.SelectObject(rPen); 
	dc.Rectangle(home.x-10,home.y-10,end.x+10,end.y+10);
	dc.SelectObject(qPen); dc.SelectObject(fArial);
	for (i=1;i<=N;i++)
		for (j=1;j<=N;j++)
			if (v[i].wt[j]!=99)
			{
				dc.MoveTo(CPoint(v[i].home)); 
				dc.LineTo(CPoint(v[j].home));
				mPoint=CPoint((v[i].home.x+v[j].home.x)/2,
					(v[i].home.y+v[j].home.y)/2);
				s.Format(L"%d",v[i].wt[j]);
				dc.TextOut(mPoint.x,mPoint.y,s);
			}
	dc.SelectObject(fHelvetica); dc.SelectObject(mPen);
	for (i=1;i<=N;i++)
		DrawNode(i);
	dc.TextOut(home.x+300,25,L"Source");
	dc.TextOut(home.x+280,55,L"Destination");
}

int CCode4A::GetCUN()
{
	int minDistance=99;
	int cun;
	for (int i=1;i<=N;i++)
		if ((!fv[i]) && (minDistance>=v[Sv].sp[i]))
		{
			minDistance=v[Sv].sp[i];
			cun=i;
		}
	return cun;
}

void CCode4A::Dijkstra()
{
	int cun;	// closest unmarked node
	int count=0;

	// initialize
	for (int i=1;i<=N;i++)
	{
		fv[i]=false;
		Pv[i]=-1;
		v[Sv].sp[i]=99;
	}
	v[Sv].sp[Sv]=0;

	// compute
	while (count<N)
	{
		cun=GetCUN();
		fv[cun]=true;
		for (int i=1;i<=N;i++)
			if ((!fv[i]) && (v[cun].wt[i]>0))
				if (v[Sv].sp[i]>v[Sv].sp[cun]+v[cun].wt[i])
				{
					v[Sv].sp[i]=v[Sv].sp[cun]+v[cun].wt[i];
					Pv[i]=cun;
				}
		count++;
	}
}

void CCode4A::DrawPath()
{ 
	CClientDC dc(this);
	CString s;
	CPen rPen(PS_SOLID,2,RGB(200,0,0));
	int i,u,w;

	// display the source			
	dc.SelectObject(fHelvetica);
	dc.SetTextColor(RGB(0,0,0));			
	dc.TextOut(end.x+100,home.y,L"Path"); 
	dc.TextOut(end.x+150,home.y,L"Weight"); 
	s.Format(L"Total Costs: %d",v[Sv].sp[Dv]); 
	dc.TextOut(end.x+100,end.y,s);

	w=Dv;
	dc.SelectObject(rPen);
	dc.MoveTo(v[w].home);
	DrawNode(w);
	s.Format(L"%d",Dv); dc.TextOutW(end.x+100,end.y-100,s);
	for (i=1;i<=N;i++)
	{
		u=Pv[w];
		if (u!=-1)
		{
			dc.LineTo(v[u].home);
			s.Format(L"%d",v[w].wt[u]);	
			dc.TextOutW(end.x+150,end.y-100-60*i,s);
			w=u; 
			DrawNode(u);
			s.Format(L"%d",w); 
			dc.TextOutW(end.x+100,end.y-130-60*i,s);
		}
	}
}

void CCode4A::OnCompute()
{
	CString s;
	eSv.GetWindowText(s); Sv=_ttoi(s);
	eDv.GetWindowText(s); Dv=_ttoi(s);
	Dijkstra(); DrawPath();
}

void CCode4A::OnNewGraph()
{
	Initialize(); Invalidate();
}