// Code5B.cpp
#include "Code5B.h"
BEGIN_MESSAGE_MAP(CCode5B,CFrameWnd)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_COMPUTE,OnCompute)
	ON_BN_CLICKED(IDC_NGRAPH,OnNewGraph)
END_MESSAGE_MAP()

CCode5B::CCode5B()
{
	Home=CPoint(30,100); End=CPoint(500,700);
	Create(NULL,L"Kruskal's Algorithm for Construction Planning Problem",
		WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
	bNGraph.Create(L"The Huts",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(30,30),CSize(180,40)),this,IDC_NGRAPH);	
	bCompute.Create(L"Compute Minimum Cost",WS_CHILD | WS_VISIBLE 
		| BS_DEFPUSHBUTTON,CRect(CPoint(Home.x+200,30),CSize(180,40)),
		this,IDC_COMPUTE);
	fArial.CreatePointFont(100,L"Arial"); 
	fCourier.CreatePointFont(60,L"Courier");
	Initialize();
}

void CCode5B::Initialize()
{
	int i,j;
	double distance;
	tWeight.DestroyWindow(); tST.DestroyWindow();
	srand(time(0));
	for (i=1;i<=N;i++)
	{
		v[i].Home.x=Home.x+20+rand()%(End.x-Home.x-50);
		v[i].Home.y=Home.y+20+rand()%(End.y-Home.y-50);
		v[i].rct=CRect(CPoint(v[i].Home.x-10,v[i].Home.y-10),CSize(25,25));
	}	
	nEdges=0;
	for (i=1;i<=N;i++)
	{
		e[i][i].Wt=0; e[i][i].ST=0;
		for (j=i+1;j<=N;j++)
		{		
			distance=sqrt(pow(double(v[i].Home.x-v[j].Home.x),2)
				+pow(double(v[i].Home.y-v[j].Home.y),2));
			e[i][j].ST=0; e[j][i].ST=0;
			if (distance<R)
			{
				e[i][j].Wt=1+rand()%9; 
				nEdges++;
				graph_edge[nEdges][1]=i;
				graph_edge[nEdges][2]=j;
				graph_edge[nEdges][3]=e[i][j].Wt;
			}
			else
				e[i][j].Wt=99;
			e[j][i].Wt=e[i][j].Wt;
		}
	}
}

void CCode5B::OnNewGraph()
{
	Initialize(); Invalidate();
}

void CCode5B::OnPaint()
{
	CPaintDC dc(this);
	CString s;
	int i,j;
	CPoint mPoint;
	CPen mPen(PS_SOLID,3,RGB(0,0,0));
	CPen qPen(PS_SOLID,1,RGB(150,150,150));
	dc.SelectObject(mPen);
	dc.Rectangle(Home.x-10,Home.y-10,End.x+10,End.y+10);
	dc.SelectObject(qPen); dc.SelectObject(fCourier);
	for (i=1;i<=N;i++)
		for (j=1;j<=N;j++)
			if (e[i][j].Wt!=99)
			{
				dc.MoveTo(CPoint(v[i].Home)); 
				dc.LineTo(CPoint(v[j].Home));
				s.Format(L"%d",e[i][j].Wt);
				dc.TextOut((v[i].Home.x+v[j].Home.x)/2,
					(v[i].Home.y+v[j].Home.y)/2,s);
				mPoint=CPoint((v[i].Home.x+v[j].Home.x)/2,
					(v[i].Home.y+v[j].Home.y)/2);
			}
	UpdateNodes();
}

void CCode5B::UpdateNodes()
{
	CClientDC dc(this);
	CString s;
	CPen mPen(PS_SOLID,3,RGB(0,0,0));
	dc.SelectObject(mPen); dc.SelectObject(fArial); 
	for (int i=1;i<=N;i++)
	{
		dc.Rectangle(v[i].rct);
		s.Format(L"%d",i); 
		dc.TextOutW(v[i].Home.x-5,v[i].Home.y-5,s);
	}
}

void CCode5B::ShowResults()
{
	CClientDC dc(this);
	CString s;
	int i,j;
	tWeight.Create(WS_VISIBLE|WS_CHILD|WS_DLGFRAME|LVS_REPORT
		|LVS_NOSORTHEADER,CRect(CPoint(End.x+30,Home.y),CSize(355,200)),
		this,IDC_tWEIGHT);
	tWeight.InsertColumn(0,L"",LVCFMT_CENTER,1);
	tST.Create(WS_VISIBLE|WS_CHILD|WS_DLGFRAME|LVS_REPORT
		|LVS_NOSORTHEADER,CRect(CPoint(End.x+30,Home.y+250),CSize(355,200)),
		this,IDC_tST);
	tST.InsertColumn(0,L"",LVCFMT_CENTER,1);

	for (j=1;j<=N;j++)
	{
		s.Format(L"%d",j);
		tWeight.InsertColumn(j,s,LVCFMT_CENTER,35);
		s.Format(L"%d",j);
		tST.InsertColumn(j,s,LVCFMT_CENTER,35);
	}
	for (i=1;i<=N;i++)
		for (j=0;j<=N;j++)
		{
			if (j==0)
			{
				s.Format(L"%d",i);
				tWeight.InsertItem(i-1,s,0);				
				s.Format(L"%d",i);
				tST.InsertItem(i-1,s,0);
			}
			if (j>0)
			{
				s.Format(L"%d",e[i][j].Wt);
				tWeight.SetItemText(i-1,j,s);
				s.Format(L"%d",((e[i][j].ST)?e[i][j].Wt:0));
				tST.SetItemText(i-1,j,s);
			}			
		}	
	UpdateNodes();
	s.Format(L"The Minimum Cost for pavement construction =%d",MSTcost);
	dc.TextOut(End.x+30,Home.y-50,s);
	dc.TextOutW(End.x+30,Home.y-20,L"Cost Route Matrix");
	dc.TextOutW(End.x+30,Home.y+230,L"Spanning Tree Matrix for Minimum Pavement Construction ");
}

void CCode5B::OnCompute()
{
	Kruskal();
	ShowResults();
}

void CCode5B::SortEdges()
{
	int i,j,t;
	for (i=1;i<=nEdges-1;i++)
		for (j=1;j<=nEdges-i;j++)
			if (graph_edge[j][3]>graph_edge[j+1][3])
			{
				t=graph_edge[j][1];
				graph_edge[j][1]=graph_edge[j+1][1];
				graph_edge[j+1][1]=t;
				t=graph_edge[j][2];
				graph_edge[j][2]=graph_edge[j+1][2];
				graph_edge[j+1][2]=t;
				t=graph_edge[j][3];
				graph_edge[j][3]=graph_edge[j+1][3];
				graph_edge[j+1][3]=t;
			}
}

void CCode5B::Kruskal()
{
	CClientDC dc(this);
	CString s;
	CPen pMSTpath(PS_SOLID,3,RGB(200,100,100));
	int p1,p2,i,j;
	int p,q;
	SortEdges();
	for (i=1;i<=N;i++)
	{
		sets[i][1]=i;
		top[i]=1;
	}
	dc.SelectObject(pMSTpath);
	MSTcost=0;
	for (i=1;i<=nEdges;i++)
	{
		p1=FindNode(graph_edge[i][1]);
		p2=FindNode(graph_edge[i][2]);
		if (p1!=p2)
		{
			p=graph_edge[i][1]; q=graph_edge[i][2];
			tree[graph_edge[i][1]][graph_edge[i][2]]=graph_edge[i][3];
			tree[graph_edge[i][2]][graph_edge[i][1]]=graph_edge[i][3];
			dc.MoveTo(v[p].Home); dc.LineTo(v[q].Home);
			MSTcost += graph_edge[i][3];
			e[p][q].ST=1; e[q][p].ST=1;
			for (j=1;j<=top[p2];j++)
			{
				top[p1]++;
				sets[p1][top[p1]]=sets[p2][j];
			}
			top[p2]=0;
		}
	}

}

int CCode5B::FindNode(int n)
{
	int i,j;
	for (i=1;i<=nEdges;i++)
		for (j=1;j<=top[i];j++)
			if (n==sets[i][j])
				return i;
	return -1;
}
