// Code5C.cpp
#include "Code5C.h"
BEGIN_MESSAGE_MAP(CCode5C,CFrameWnd)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_COMPUTE,OnCompute)
	ON_BN_CLICKED(IDC_NGRAPH,OnNewGraph)
END_MESSAGE_MAP()

CCode5C::CCode5C()
{
	Home=CPoint(30,100); End=CPoint(500,700);
	Create(NULL,L"Kruskal's Algorithm for broadcasting problems in a network",
		WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
	bNGraph.Create(L"Ad Hoc Wireless Network",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(30,30),CSize(180,40)),this,IDC_NGRAPH);	
	bCompute.Create(L"Compute Minimum Cost",WS_CHILD | WS_VISIBLE 
		| BS_DEFPUSHBUTTON,CRect(CPoint(Home.x+200,30),CSize(180,40)),
		this,IDC_COMPUTE);
	fArial.CreatePointFont(100,L"Arial"); 
	fCourier.CreatePointFont(60,L"Courier");
	Initialize();
}

void CCode5C::Initialize()
{
	int i,j;
	double distance;
	tWeight.DestroyWindow(); tST.DestroyWindow();
	srand(time(0));
	for (i=1;i<=N;i++)
	{
		v[i].Home.x=Home.x+20+rand()%(End.x-Home.x-50);
		v[i].Home.y=Home.y+20+rand()%(End.y-Home.y-50);
		v[i].rct=CRect(CPoint(v[i].Home.x-10,v[i].Home.y-10),CSize(25,25));
	}	
	nEdges=0;
	for (i=1;i<=N;i++)
	{
		e[i][i].Wt=0; e[i][i].ST=0;
		for (j=i+1;j<=N;j++)
		{		
			distance=sqrt(pow(double(v[i].Home.x-v[j].Home.x),2)
				+pow(double(v[i].Home.y-v[j].Home.y),2));
			e[i][j].ST=0; e[j][i].ST=0;
			if (distance<R)
			{
				e[i][j].Wt=1+rand()%9; 
				nEdges++;
				graph_edge[nEdges][1]=i;
				graph_edge[nEdges][2]=j;
				graph_edge[nEdges][3]=e[i][j].Wt;
			}
			else
				e[i][j].Wt=99;
			e[j][i].Wt=e[i][j].Wt;
		}
	}
}

void CCode5C::OnNewGraph()
{
	Initialize(); Invalidate();
}

void CCode5C::OnPaint()
{
	CPaintDC dc(this);
	CString s;
	int i,j;
	CPoint mPoint;
	CPen mPen(PS_SOLID,3,RGB(0,0,0));
	CPen qPen(PS_SOLID,1,RGB(150,150,150));
	dc.SelectObject(mPen);
	dc.Rectangle(Home.x-10,Home.y-10,End.x+10,End.y+10);
	dc.SelectObject(qPen); dc.SelectObject(fCourier);
	for (i=1;i<=N;i++)
		for (j=1;j<=N;j++)
			if (e[i][j].Wt!=99)
			{
				dc.MoveTo(CPoint(v[i].Home)); 
				dc.LineTo(CPoint(v[j].Home));
				s.Format(L"%d",e[i][j].Wt);
				dc.TextOut((v[i].Home.x+v[j].Home.x)/2,
					(v[i].Home.y+v[j].Home.y)/2,s);
				mPoint=CPoint((v[i].Home.x+v[j].Home.x)/2,
					(v[i].Home.y+v[j].Home.y)/2);
			}
	UpdateNodes();
}

void CCode5C::UpdateNodes()
{
	CClientDC dc(this);
	CString s;
	CPen mPen(PS_SOLID,3,RGB(0,0,0));
	dc.SelectObject(mPen); dc.SelectObject(fArial); 
	for (int i=1;i<=N;i++)
	{
		dc.Rectangle(v[i].rct);
		s.Format(L"%d",i); 
		dc.TextOutW(v[i].Home.x-5,v[i].Home.y-5,s);
	}
}

void CCode5C::ShowResults()
{
	CClientDC dc(this);
	CString s;
	int i,j;
	tWeight.Create(WS_VISIBLE|WS_CHILD|WS_DLGFRAME|LVS_REPORT
		|LVS_NOSORTHEADER,CRect(CPoint(End.x+30,Home.y),CSize(355,200)),
		this,IDC_tWEIGHT);
	tWeight.InsertColumn(0,L"",LVCFMT_CENTER,1);
	tST.Create(WS_VISIBLE|WS_CHILD|WS_DLGFRAME|LVS_REPORT
		|LVS_NOSORTHEADER,CRect(CPoint(End.x+30,Home.y+250),CSize(355,200)),
		this,IDC_tST);
	tST.InsertColumn(0,L"",LVCFMT_CENTER,1);

	for (j=1;j<=N;j++)
	{
		s.Format(L"%d",j);
		tWeight.InsertColumn(j,s,LVCFMT_CENTER,35);
		s.Format(L"%d",j);
		tST.InsertColumn(j,s,LVCFMT_CENTER,35);
	}
	for (i=1;i<=N;i++)
		for (j=0;j<=N;j++)
		{
			if (j==0)
			{
				s.Format(L"%d",i);
				tWeight.InsertItem(i-1,s,0);				
				s.Format(L"%d",i);
				tST.InsertItem(i-1,s,0);
			}
			if (j>0)
			{
				s.Format(L"%d",e[i][j].Wt);
				tWeight.SetItemText(i-1,j,s);
				s.Format(L"%d",((e[i][j].ST)?e[i][j].Wt:0));
				tST.SetItemText(i-1,j,s);
			}			
		}	
	UpdateNodes();
	dc.TextOutW(End.x+30,Home.y-20,L"Transmission Cost Matrix");
	dc.TextOutW(End.x+30,Home.y+230,L"Spanning Tree Matrix");
}

void CCode5C::OnCompute()
{
	Kruskal();
	ShowResults();
}

void CCode5C::SortEdges()
{
	int i,j,t;
	for (i=1;i<=nEdges-1;i++)
		for (j=1;j<=nEdges-i;j++)
			if (graph_edge[j][3]>graph_edge[j+1][3])
			{
				t=graph_edge[j][1];
				graph_edge[j][1]=graph_edge[j+1][1];
				graph_edge[j+1][1]=t;
				t=graph_edge[j][2];
				graph_edge[j][2]=graph_edge[j+1][2];
				graph_edge[j+1][2]=t;
				t=graph_edge[j][3];
				graph_edge[j][3]=graph_edge[j+1][3];
				graph_edge[j+1][3]=t;
			}
}

void CCode5C::Kruskal()
{
	CClientDC dc(this);
	CString s;
	CPen pMSTpath(PS_SOLID,3,RGB(255,0,0));
	int p1,p2,i,j;
	int p,q;
	int a[N+1],b[N+1],c[N+1];
	bool statustn[N+1]; 
	SortEdges();
	for (i=1;i<=N;i++)
	{
		sets[i][1]=i;
		top[i]=1;
	}

	CString str, strp;
	table.Create(WS_VISIBLE|WS_CHILD|WS_DLGFRAME|LVS_REPORT
	|LVS_NOSORTHEADER,CRect(CPoint(End.x+400,Home.y+250),CSize(285,200)),
	this,IDC_tST);
	table.InsertColumn(0,L"k",LVCFMT_CENTER,70);
	table.InsertColumn(1,L"p",LVCFMT_CENTER,70);
	table.InsertColumn(2,L"q",LVCFMT_CENTER,70);
	table.InsertColumn(3,L"cost",LVCFMT_CENTER,70);
	
	dc.SelectObject(pMSTpath);
	int k=1;
	for (i=1;i<=nEdges;i++)
	{
		
		p1=FindNode(graph_edge[i][1]);
		p2=FindNode(graph_edge[i][2]);
		if (p1!=p2)
		{
			p=graph_edge[i][1]; q=graph_edge[i][2];
			tree[graph_edge[i][1]][graph_edge[i][2]]=graph_edge[i][3];
			tree[graph_edge[i][2]][graph_edge[i][1]]=graph_edge[i][3];
			dc.MoveTo(v[p].Home); dc.LineTo(v[q].Home);
										
			a[k]=p;
			b[k]=q;
			c[k]=graph_edge[i][3];
			k++;

			e[p][q].ST=1; e[p][q].ST=1;
			for (j=1;j<=top[p2];j++)
			{
				top[p1]++;
				sets[p1][top[p1]]=sets[p2][j];
			}
			top[p2]=0;
		}
		
	}
	int sum=k;
	for (k=1;k<=sum-1;k++)
	{
			str.Format(L"%d",k); table.InsertItem(k-1,str,0);
			str.Format(L"%d",a[k]); table.SetItemText(k-1,1,str);
			str.Format(L"%d",b[k]); table.SetItemText(k-1,2,str);
			str.Format(L"%d",c[k]); table.SetItemText(k-1,3,str);			
	}
	
	int	tn[N+1][N+1], temp_edge[N], costtn[N+1][N+1];
	int m, totaltn, max_cost_tn[N+1];
	int number_tn[N+1];
	for(i=1;i<=N-1;i++)
		statustn[i]=true;
	m=1; 
	for (i=1;i<=N-1;i++)
	{
		if ( statustn[i] == true )
		{
			k=1;
			for (j=i+1;j<=N-1;j++)
			{
				if (a[i]==a[j])
				{
					k++;
					tn[m][k]=a[j];
					costtn[m][k]=c[j];
					statustn[j]=false;
				}
			}
			tn[m][1]=a[i];
			costtn[m][1]=c[i];
			max_cost_tn[m]=costtn[m][k];
			m++;
		}
	}
	totaltn=m-1;
	
	s.Format(L"number of transmission node is %d",totaltn); 
	dc.TextOut(900,500,s);

	dc.TextOutW(End.x+400,Home.y+230,L"Edges selected for MST");
	tableP.Create(WS_VISIBLE|WS_CHILD|WS_DLGFRAME|LVS_REPORT
	|LVS_NOSORTHEADER,CRect(CPoint(End.x+400,Home.y),CSize(285,200)),
	this,IDC_tST);
	tableP.InsertColumn(0,L"Transmission Node",LVCFMT_CENTER,130);
	tableP.InsertColumn(1,L"Max Transmission Power",LVCFMT_CENTER,150);
	
	for (k=1;k<=totaltn;k++)
	{
			str.Format(L"%d",tn[k][1]); tableP.InsertItem(k-1,str,0);
			str.Format(L"%d",max_cost_tn[k]); tableP.SetItemText(k-1,1,str);
	}

	total_cost=0;
	for (i=1;i<=totaltn;i++)
		{
			total_cost += max_cost_tn[i]; 		
		}
	s.Format(L"Total cost of overall transmission power in the Ad Hoc Wireless Network is %d",total_cost); 
	dc.TextOut(End.x+30, Home.y-50,s);
}

int CCode5C::FindNode(int n)
{
	int i,j;
	for (i=1;i<=nEdges;i++)
		for (j=1;j<=top[i];j++)
			if (n==sets[i][j])
				return i;
	return -1;
}


