﻿// Code6A.cpp: Max cliques
#include "Code6A.h"

BEGIN_MESSAGE_MAP(CCode6A,CFrameWnd)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_NGRAPH,OnNewGraph)
	ON_BN_CLICKED(IDC_COMPUTE,OnCompute)
END_MESSAGE_MAP()

CCode6A::CCode6A()
{
	Home=CPoint(30,100); End=CPoint(500,700);
	Create(NULL,L"Computing the Maximum Clique of a Graph",
		WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800),NULL);
	bNGraph.Create(L"New Graph",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(Home.x,30),CSize(180,40)),this,IDC_NGRAPH);	
	bCompute.Create(L"Compute",WS_CHILD | WS_VISIBLE 
		| BS_DEFPUSHBUTTON,CRect(CPoint(Home.x+200,30),CSize(180,40)),
		this,IDC_COMPUTE);
	fArial.CreatePointFont(80,L"Arial");
	fVerdana.CreatePointFont(100,L"Verdana");
	int Color[]={RGB(150,150,150),RGB(0,0,0),RGB(0,0,200)};
	for (int i=0;i<=2;i++)
		if (i==0)
			pColor[i].CreatePen(PS_SOLID,1,Color[i]);
		else
			pColor[i].CreatePen(PS_SOLID,3,Color[i]);	
	Initialize();
}

void CCode6A::OnNewGraph()
{
	Initialize(); Invalidate();
}

void CCode6A::Initialize()
{
	int i,j;
	double distance;
	srand(time(0));
	for (i=1;i<=N;i++)
	{
		v[i].Home.x=Home.x+20+rand()%(End.x-Home.x-50);
		v[i].Home.y=Home.y+20+rand()%(End.y-Home.y-50);
		v[i].rct=CRect(CPoint(v[i].Home.x-10,v[i].Home.y-10),CSize(25,25));
	}	
	for (i=1;i<=N;i++)
	{
		e[i][i].adj=0;
		for (j=i+1;j<=N;j++)
		{		
			distance=sqrt(pow(double(v[i].Home.x-v[j].Home.x),2)
				+pow(double(v[i].Home.y-v[j].Home.y),2));
			e[i][j].adj=((distance<=LinkRange)?1:0);
			e[j][i].adj=e[i][j].adj;
		}
	}
}

void CCode6A::OnPaint()
{
	CPaintDC dc(this);
	CString s;
	int i,j;
	dc.SelectObject(pColor[1]);
	dc.Rectangle(Home.x-10,Home.y-10,End.x+10,End.y+10);
	dc.SelectObject(pColor[0]);
	for (i=1;i<=N;i++)
		for (j=1;j<=N;j++)
			if (e[i][j].adj)
			{
				dc.MoveTo(CPoint(v[i].Home)); 
				dc.LineTo(CPoint(v[j].Home));
			}
	dc.SelectObject(fArial); dc.SelectObject(pColor[1]);
	for (i=1;i<=N;i++)
	{
		dc.Rectangle(v[i].rct);
		s.Format(L"%d",i); 
		dc.TextOutW(v[i].Home.x-5,v[i].Home.y-5,s);
	}	
}

void CCode6A::MaxClique()
{	
	int  i,j,r,t,k,maxi,a;
	for (i=1; i<=N; i++)
	{	
		k=0;
		for (j=1; j<=N; j++)
			if (e[i][j].adj==1)
				{
					k++;
					p[k]=j;
				}
		vCliq[1]=i;
		max[i]=1;
		a=1;
		for (r=1; r<k; r++)
		{
			maxi=0;
			for (t=r+1; t<=k; t++)
				if (e[p[r]][p[t]].adj==1)
					maxi++;
			if (maxi==(k-r))
			{	
				a++;
				vCliq[a]=p[r];
				max[i]++;	
			}
		}
		a++;
		vCliq[a]=p[k];
		max[i]++;
	}	
	maximum=max[1];
	for (int c=2;c<=N;c++)
		if (max[c]>=maximum)
			maximum=max[c];
	for (int i=1;i<=N;i++)
		if (max[i]==maximum)
		{
			k=0;
			for(j=1; j<=N; j++)
				if(e[i][j].adj==1)
				{	
					k++;
					p[k]=j;
				}
			vCliq[1]=i;
			max[i]=1;
			a=1;
			for (r=1; r<k; r++)
			{
				maxi=0;
				for (t=r+1; t<=k; t++)
					if (e[p[r]][p[t]].adj==1)
						maxi++;
				if (maxi==(k-r))
				{
					a++;
					vCliq[a]=p[r];
					max[i]++;
				}
			}
			a++;
			vCliq[a]=p[k];
			max[i]++; nCliq=max[i];
		}
}

void CCode6A::OnCompute()
{
	CClientDC dc(this);
	CString s;
	int i,j;
	MaxClique();
	dc.SelectObject(&pColor[2]);
	for (i=1;i<=nCliq;i++)	// draw the subgraph
		for (j=i+1;j<=nCliq;j++)
		{			
			dc.MoveTo(v[vCliq[i]].Home); 
			dc.LineTo(v[vCliq[j]].Home);
		}
	dc.SetTextColor(RGB(0,0,0)); dc.SelectObject(fVerdana);
	for (i=1;i<=nCliq;i++)
	{			
		dc.Rectangle(v[vCliq[i]].rct);
		s.Format(L"%d",vCliq[i]);
		dc.TextOutW(v[vCliq[i]].Home.x-5,v[vCliq[i]].Home.y-5,s);
		dc.TextOutW(End.x+30,Home.y+200+i*20,s);
	}
}
