// Code 7A.cpp
#include "Code7A.h"
using namespace std;

BEGIN_MESSAGE_MAP(CFP,CFrameWnd)
	ON_WM_PAINT()
	ON_BN_CLICKED(20,OnCompute)
	ON_BN_CLICKED(21,OnResult)
	ON_BN_CLICKED(22,OnClear)
END_MESSAGE_MAP()

CFP::CFP()
{
	Create(NULL,L"Computation Geometry",WS_OVERLAPPEDWINDOW,CRect(0,0,900,900));
	eNodes.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
        CRect(CPoint(120,40),CSize(100,25)),this,11);
	bCompute.Create(L"Compute",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 
		CRect(CPoint(250,40),CSize(130,25)),this,20);
	bResult.Create(L"Result",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 
		CRect(CPoint(400,40),CSize(130,25)),this,21);	
	bClear.Create(L"Clear",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 
		CRect(CPoint(550,40),CSize(130,25)),this,22);

}

CFP::~CFP()
{	
}

void CFP::OnPaint()
{
	CPaintDC dc(this);
	CFont F1;
	CRect rct1;
	F1.CreatePointFont(12,L"Courier");

	rct1=CRect(CPoint(30,10),CSize(800,800));
	dc.Rectangle(rct1);
	dc.SelectObject(F1);
	dc.TextOut(120,20,L"#Nodes (Please enter a number between 3 to 100)");
}

void CFP::OnCompute()
{
	CClientDC dc(this);

	int i;

	CFont F1;
	F1.CreatePointFont(50,L"Courier");
	dc.SelectObject(F1);

	CString s;
	eNodes.GetWindowText(s);
	n=_ttoi(s);

	srand(time(NULL));

	if(n>N || n<3)
	{
			dc.TextOutW(100,100,L"invalid input");
	}
	else
	{
		for(i=1;i<=n;i++)
		{
			p[i].x=90+rand()%660;
			p[i].y=90+rand()%660;
			p[i].rct=CRect(CPoint(p[i].x,p[i].y),CSize(5,5));
			dc.Rectangle(p[i].rct);
		}
	}
}

void CFP::OnResult()
{
	CClientDC dc(this);
	CString s;
	Point tmp;
	int i,j,k=0,a=1,b,c;


	for(j=1;j<=n;j++)
		for(i=1;i<=n-1;i++)
			if((p[i].y < p[i+1].y) || ((p[i].y==p[i+1].y) && (p[i].x<p[i+1].x))) // detect anchor point (lowest y-coordinates point)
			{
			tmp = p[i];
			p[i] = p[i+1];
			p[i+1] = tmp;
			}

	for(j=1;j<=n;j++)
		for(i=1;i<=n-1;i++)
			if((((p[i].x-p[1].x)*(-p[i+1].y+p[1].y)-(p[i+1].x-p[1].x)*(-p[i].y+p[1].y))<0) ||
				(((p[i].x-p[1].x)*(-p[i+1].y+p[1].y)-(p[i+1].x-p[1].x)*(-p[i].y+p[1].y))<0) &&
				(sqrt(double((p[1].x-p[i].x)*(p[1].x-p[i].x) + (p[1].y-p[i].y)*(p[1].y-p[i].y)))<
				sqrt(double((p[1].x-p[i+1].x)*(p[1].x-p[i+1].x) + (p[1].y-p[i+1].y)*(p[1].y-p[i+1].y)))))
			{
			tmp = p[i];
			p[i] = p[i+1];
			p[i+1] = tmp;
			}

	top = 0;
	que[++top] = p[1];
	que[++top] = p[2];
	que[++top] = p[3]; // top=3

	for(i=4;i<=n;i++)
	{
			
		if((((p[i].x-que[top-1].x)*(-que[top].y+que[top-1].y)-(que[top].x-que[top-1].x)*(-p[i].y+que[top-1].y))>0))
		{
			// turn right
				que[top]=p[i];
				top--;
				i--;
		}
		else
		{
			que[++top]=p[i];
		}
	
	}
	for(i=1; i<top;i++)
	{
		dc.MoveTo(que[i].x,que[i].y);
		dc.LineTo(que[i+1].x,que[i+1].y);
	}
	dc.MoveTo(que[1].x,que[1].y);
	dc.LineTo(que[top].x,que[top].y);

	b=top;
	c=n-top;

	while(1)
	{
		if(c>2)
		{
			for(i=1;i<=n;i++)
				for(j=1;j<=b;j++)
				{
					if(p[i].x==que[j].x && p[i].y== que[j].y)
					{
						p[i].x=0;
						p[i].y=-1;
					}
				}
			for(j=1;j<=n;j++)
				for(i=1;i<=n-1;i++)
					if((p[i].y < p[i+1].y) || ((p[i].y==p[i+1].y) && (p[i].x<p[i+1].x))) // detect anchor point (lowest y-coordinates point)
					{
						tmp = p[i];
						p[i] = p[i+1];
						p[i+1] = tmp;
					}
			for(j=1;j<=c;j++)
				for(i=1;i<=c-1;i++)
					if((((p[i].x-p[1].x)*(-p[i+1].y+p[1].y)-(p[i+1].x-p[1].x)*(-p[i].y+p[1].y))<0) ||
						(((p[i].x-p[1].x)*(-p[i+1].y+p[1].y)-(p[i+1].x-p[1].x)*(-p[i].y+p[1].y))<0) &&
						(sqrt(double((p[1].x-p[i].x)*(p[1].x-p[i].x) + (p[1].y-p[i].y)*(p[1].y-p[i].y)))<
						sqrt(double((p[1].x-p[i+1].x)*(p[1].x-p[i+1].x) + (p[1].y-p[i+1].y)*(p[1].y-p[i+1].y)))))
					{
						tmp = p[i];
						p[i] = p[i+1];
						p[i+1] = tmp;
					}
		
			top = 0;
			que[++top] = p[1];
			que[++top] = p[2];
			que[++top] = p[3]; // top=3

			for(i=4;i<=c;i++)
			{
			
				if((((p[i].x-que[top-1].x)*(-que[top].y+que[top-1].y)-(que[top].x-que[top-1].x)*(-p[i].y+que[top-1].y))>0))
				{
					// turn right
					que[top]=p[i];
					top--;
					i--;
				}
				else
				{
					que[++top]=p[i];
				}
	
			}
			for(i=1; i<top;i++)
			{
				dc.MoveTo(que[i].x,que[i].y);
				dc.LineTo(que[i+1].x,que[i+1].y);
			}
			dc.MoveTo(que[1].x,que[1].y);
			dc.LineTo(que[top].x,que[top].y);
			b=top;
			c=c-top;
		}
		else
			break;
	}
}

void CFP::OnClear()
{
	CClientDC dc(this);
	CRect rc;
	InvalidateRect(&rc);
	Invalidate();
}