// Code8A.cpp: Jobs on rectangular mesh network
#include "Code8A.h"

BEGIN_MESSAGE_MAP(CCode8A, CFrameWnd)
	ON_WM_PAINT()       
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()

CCode8A::CCode8A()
{
	hBar=8; sBar=3;
	home=CPoint(150,0); end=CPoint(900,200);
	Create(NULL,L"Dynamic Machine Scheduling Model",
		WS_OVERLAPPEDWINDOW,CRect(0,0,900,700));
	t=0; n=0; nSuccessfulJobs=0;
	for (int k=1;k<=M*M;k++)
	{
		PE[k].status=0;
		PE[k].totJobs=0;
		PE[k].totExecTime=0;
	}
	mPE[1][1].home=CPoint(home.x+50,end.y+50);
	mPE[1][1].rct=CRect(CPoint(mPE[1][1].home),CSize(50,50));
	for (int j=1;j<=M;j++)
		for (int i=1;i<=M;i++)
		{
			mPE[i][j].home=mPE[1][1].home+CPoint(80*(i-1),80*(j-1));
			mPE[i][j].rct=CRect(mPE[i][j].home,mPE[i][j].home+CPoint(40,40));
		}
	fArial.CreatePointFont (70,L"Arial");
}

void CCode8A::OnPaint()
{
	CPaintDC dc(this);
	CString s;
	dc.TextOut(home.x+100,640,
		L"Press SPACEBAR to simulate the discrete event");
	CPen pBlue(PS_SOLID,1,RGB(100,100,100));
	dc.SelectObject(&pBlue);
	dc.Rectangle(CRect(home.x-140,home.y+10,end.x-30,635));
	dc.MoveTo(home.x-140,home.y+195); dc.LineTo(end.x-31,home.y+195);
	dc.MoveTo(home.x-110,home.y+10); dc.LineTo(home.x-110,home.y+195);
	dc.MoveTo(home.x-70,home.y+10); dc.LineTo(home.x-70,home.y+195);
	dc.MoveTo(home.x-5,home.y+10); dc.LineTo(home.x-5,home.y+195);
	dc.SelectObject (&fArial);
	for (int i=1;i<=M*M;i++)
	{
		s.Format(L"%d",i);
		dc.TextOut(20,3+(hBar+sBar)*i,s);
	}
	DrawMesh();
}

void CCode8A::OnKeyDown(UINT nChar, UINT nRep, UINT nFlags)
{
	CClientDC dc(this);
	CString s;
	CRect rct;
	CBrush bWhite(RGB(255,255,255));
	CPen pGray(PS_SOLID,1,RGB(255,255,255));
	CPen pRed(PS_SOLID,1,RGB(255,0,0));
	CPen pBlack(PS_SOLID,1,RGB(50,50,50));
	CPen pBlue(PS_SOLID,1,RGB(0,0,250));
	int acc[M*M+1],BusyPE[M*M+1];
	int aPE,nIncJobs;	// aPE=assigned PE
	int i,k,q,r,w,nAvailPE,nBusyPE,nNewBusyPE;
	dc.SelectObject(&fArial);
	srand(time(0));
	if (nChar==VK_SPACE && (n<=N && t<=65))
	{
		dc.SelectObject(&pRed);
		dc.MoveTo(home.x+(t+1)*8,home.y+6); 
		dc.LineTo(home.x+(t+1)*8,home.y+10);
		dc.SelectObject(&pGray);
		dc.MoveTo(home.x+(t+1)*8,home.y+12);
		dc.LineTo(home.x+(t+1)*8,home.y+15+(hBar+sBar)*M*M);
		dc.FillRect(CRect(home.x-48,home.y+12,home.x-7,home.y+190),&bWhite);
		s.Format(L"t=%d",t++);
		dc.TextOut(30,300,s);
		nIncJobs=rand()%nIncJobsMax;
		s.Format(L"Max.Incoming Jobs: %d   ",nIncJobsMax);
		dc.TextOut(30,310,s);
		s.Format(L"Incoming Jobs: %d   ",nIncJobs);
		dc.TextOut(30,320,s);
		w=0; 
		for (k=1;k<=M*M;k++)
		{
			if (PE[k].totJobs>=1)
			{
				r=PE[k].lastJob;
				if (v[r].act<=t)
					PE[k].status=FALSE;
			}
			if (!PE[k].status)
			{
				rct=CRect(CPoint(home.x-66,5+(hBar+sBar)*k),CSize(5,5));
				dc.SelectObject(&pBlack);
				dc.Rectangle(&rct);
				acc[++w]=k;
			}
			else
			{
				rct=CRect(CPoint(home.x-66,5+(hBar+sBar)*k),CSize(5,5));
				dc.FillSolidRect(&rct,RGB(255,0,0));
				dc.SetTextColor(RGB(255,0,0));
				dc.SetBkColor(RGB(255,255,255));
				r=PE[k].lastJob;
				s.Format(L"%d,%d",r,v[r].length);
				dc.TextOut(home.x-50,3+(hBar+sBar)*k,s);
			}
		}
		nBusyPE=0; 
		for (k=1;k<=M*M;k++)
			if (PE[k].status)
				BusyPE[++nBusyPE]=k;
		nAvailPE=w;
		dc.SetBkColor(RGB(255,255,255));
		nNewBusyPE=0;
		for (i=1;i<=nIncJobs;i++)
		{
			if (++n>=N)
				break;
			v[n].status=FALSE;
			v[n].length=1+rand()%JobLengthMax;
			v[n].ast=t;
			v[n].act=v[n].ast+v[n].length;
			for (k=1;k<=M*M;k++)
				if (nAvailPE!=0)
				{
					q=1+rand()%nAvailPE;
					if (!PE[acc[q]].status)
					{
						aPE=acc[q];
						++nNewBusyPE;
						BusyPE[++nBusyPE]=aPE;
						nSuccessfulJobs++;
						v[n].aPE=aPE;
						v[n].status=TRUE;
						PE[aPE].status=TRUE;
						PE[aPE].lastJob=n;
						r=++PE[aPE].totJobs;
						PE[aPE].v[r]=n;
						PE[aPE].totExecTime += v[n].length;
						dc.SetTextColor(RGB(0,0,250));
						s.Format(L"%d,%d",r,PE[aPE].totExecTime);
						dc.TextOut(45,3+(hBar+sBar)*aPE,s);
						s.Format(L"%d,%d",n,v[n].length);
						dc.TextOut(home.x-50,3+(hBar+sBar)*aPE,s);
						rct=CRect(CPoint(home.x+t*8,5+(hBar+sBar)*aPE),
							CSize(8*v[n].length,hBar));
						if (PE[aPE].totJobs%2==0)
							dc.FillSolidRect(&rct,RGB(0,235,235));
						else
							dc.FillSolidRect(&rct,RGB(0,100,200));
						rct=CRect(CPoint(home.x-60,5+(hBar+sBar)*aPE),
							CSize(5,5));
						dc.FillSolidRect(&rct,RGB(0,0,180));
						break;
					}
				}
			if (!v[n].status)
				v[n].aPE=0;
			dc.SetBkColor(RGB(255,255,255));
		}
		dc.SetTextColor(RGB(0,0,0));
		s.Format(L"Successful Jobs: %d",nSuccessfulJobs);
		dc.TextOut(30,350,s);
		s.Format(L"Unsuccessful Jobs: %d",n-nSuccessfulJobs);
		dc.TextOut(30,360,s);
		double q=(double)nSuccessfulJobs/(double)n;
		s.Format(L"Success Rate: %.2lf   ",q);
		dc.TextOut(30,370,s);
		if (t==65)
			ShowTable();
		UpdateMesh(nBusyPE,nNewBusyPE,BusyPE);
	}
}

void CCode8A::ShowTable()
{
	CString s;
	table.DestroyWindow();
	table.Create(WS_VISIBLE | WS_CHILD | WS_BORDER | LVS_REPORT
				| LVS_NOSORTHEADER,CRect(home.x+380,home.y+230,
				home.x+650,home.y+600),this,IDC_TABLE);	
	table.InsertColumn(0,L"v",LVCFMT_CENTER,45);
	table.InsertColumn(1,L"Status",LVCFMT_CENTER,45);
	table.InsertColumn(2,L"L",LVCFMT_CENTER,45);
	table.InsertColumn(3,L"ast-act",LVCFMT_CENTER,45);
	table.InsertColumn(4,L"PE",LVCFMT_CENTER,45);
	for (int i=1;i<=n;i++)
	{
		s.Format(L"%d",i); table.InsertItem(i-1,s,0);
		s.Format(L"%d",v[i].status); table.SetItemText(i-1,1,s);
		s.Format(L"%d",v[i].length); table.SetItemText(i-1,2,s);
		s.Format(L"%d-%d",v[i].ast,v[i].act); table.SetItemText(i-1,3,s);
		s.Format(L"%d",v[i].aPE); table.SetItemText(i-1,4,s);
	}
}

void CCode8A::DrawMesh()
{
	CClientDC dc(this);
	CRect mRegion,cPort;
	CPoint a,b;
	CString s;
	int i,j,k=1;

	// draw the PEs
	CBrush bWhite(RGB(255,255,255));
	mRegion=CRect(home.x+110,home.y+200,home.x+360,home.y+450);
	dc.FillRect(mRegion,&bWhite);
	CPen pBlack(PS_SOLID,1,RGB(0,0,0));
	dc.SelectObject(&pBlack);
	for (j=1;j<=M;j++)
		for (i=1;i<=M;i++)
		{
			dc.Rectangle(&mPE[i][j].rct);
			dc.SetTextColor(RGB(0,0,0));
			s.Format(L"%d",k++);
			dc.TextOut(mPE[i][j].home.x+10,mPE[i][j].home.y+4,s);
		}
}

void CCode8A::UpdateMesh(int nBusyPE,int nNewBusyPE,int BusyPE[M*M+1])
{
	CClientDC dc(this);
	CString s;
	int i,j,k,p,q;
	CPen pRed(PS_SOLID,3,RGB(255,0,0));
	CPen pBlue(PS_SOLID,3,RGB(0,0,180));
	CRect rct;
	DrawMesh();
	for (k=1;k<=nBusyPE;k++)
	{
		p=BusyPE[k];
		switch(p)
		{
			case 1:
				i=1; j=1; break;
			case 2:
				i=2; j=1; break;
			case 3:
				i=3; j=1; break;
			case 4:
				i=4; j=1; break;
			case 5:
				i=1; j=2; break;
			case 6:
				i=2; j=2; break;
			case 7:
				i=3; j=2; break;
			case 8:
				i=4; j=2; break;
			case 9:
				i=1; j=3; break;
			case 10:
				i=2; j=3; break;
			case 11:
				i=3; j=3; break;
			case 12:
				i=4; j=3; break;
			case 13:
				i=1; j=4; break;
			case 14:
				i=2; j=4; break;
			case 15:
				i=3; j=4; break;
			case 16:
				i=4; j=4; break;			
		}
		if (k<=nBusyPE-nNewBusyPE)
			dc.SelectObject(&pRed);
		else
			dc.SelectObject(&pBlue);
		dc.Rectangle(&mPE[i][j].rct);
		dc.SetTextColor(RGB(0,0,0));
		s.Format(L"%d",BusyPE[k]);
		dc.TextOut(mPE[i][j].home.x+10,mPE[i][j].home.y+4,s);
		q=PE[p].lastJob;
		dc.SetTextColor(RGB(0,0,220));
		s.Format(L"%d",q);
		dc.TextOut(mPE[i][j].home.x+10,mPE[i][j].home.y+20,s);
	}
}

