// Code8B.h
#include <afxwin.h>
#include <afxcmn.h>
#include <fstream>
#define N 20				// Max #nodes
#define nPE 4				// #PE
#define IDC_SCHEDULE 500
#define IDC_table 501
#define IDC_NGRAPH 502
#define nFIELDS 7
#define L (double)0.2
using namespace std;

typedef struct		// Cartesian points
{
	double x,y;
} PT;

class CCode8B : public CFrameWnd
{
private:
	CPoint WHome,WEnd;
	PT CHome,CEnd;
	CFont fCourier,fTimes;
	CButton TSbutton,bNGraph;
	CListCtrl table;
	int n,RButtonFlag,pt1,pt2;
	int TextColor,BgColor;

	typedef struct
	{
		int len;			// length
		int aPE;			// assigned Processor
		int pmm;			// path max. magnitude
		int pre[5];			// pred task, pre[0]=#pred tasks
		int preCom[5];		// comm cost of pred tasks
		int ast,act;		// ast=actual start time, act=completion time
		int hrt,lrt;		// high ready time, low ready time
		int sort;			// sorted nodes according to colevels
		bool sta;			// status
		CPoint WHome,GHome;	// node coordinates in text & graphic areas
		PT CHome;
		CRect rct;			// node representation as a box
	} NODE;
	NODE v[N+1];

	typedef struct
	{
		int v[N+1];		// task# (aTs[0]=#tasks in Pr)
		int prt,pel;		// proc ready time, execution length
		CPoint WHome;
	} MACHINE;
	MACHINE PE[nPE+1];
public:
	CCode8B();
	~CCode8B()				{}
	void PreScheduler(),Scheduler(),Initialize();
	void ShowTable(),PMM(),DrawNode(int),DrawLine();
	CPoint ConvertCW(PT);
	PT ConvertWC(CPoint);
	afx_msg void OnCompute();
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown (UINT,CPoint);
	afx_msg void OnRButtonDown (UINT,CPoint);
	afx_msg void OnNGraph();
	DECLARE_MESSAGE_MAP();
};

class CMyWinApp : public CWinApp
{
public:
  virtual BOOL InitInstance();
};
CMyWinApp MyApplication;

BOOL CMyWinApp::InitInstance(void)
{
	m_pMainWnd = new CCode8B;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	return TRUE;
}
