// Code9A.cpp
#include "Code9A.h"
#define PI 3.142

BEGIN_MESSAGE_MAP(CCode9A,CFrameWnd)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_COMPUTE,OnCompute)
	ON_BN_CLICKED(IDC_NEWGRAPH,OnNewGraph)
	ON_BN_CLICKED(IDC_OMNI,OnOmnidirectional)
	ON_BN_CLICKED(IDC_DIR,OnDirectional)
END_MESSAGE_MAP()

CCode9A::CCode9A()
{
	idc=400;
	Create(NULL,L"Target tracking",WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
	home=CPoint(10,70); end=CPoint(600,660);
	CHome.x=-5; CHome.y=5; CEnd.x=5; CEnd.y=-5;
	eW.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(home.x+130,home.y-50),CSize(100,25)),this,idc++);
	bCompute.Create(L"Generate Targets",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(home.x+250,home.y-50),CSize(200,25)),this,IDC_COMPUTE);
	bNGraph.Create(L"New Graph",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(home.x+470,home.y-50),CSize(120,25)),this,IDC_NEWGRAPH);
	fArial6.CreatePointFont(60,L"arial");
	fArial8.CreatePointFont(80,L"arial");
	fArial10.CreatePointFont(100,L"arial");
	Initialize();
}

void CCode9A::OnNewGraph()
{
	CClientDC dc(this);
	CRect rct;
	CBrush pErase(RGB(255,255,255));
	rct=CRect(home.x,home.y,end.x,end.y);
	dc.FillRect(rct,&pErase);
	Initialize(); Invalidate();
}

void CCode9A::Cover(bool flag)
{
	CClientDC dc(this);
	double beta,phi,tau,tmp;
	int i;
	CString s;
	CPen pRed(PS_SOLID,1,RGB(200,0,0));
	PT a,b,c;
	CPoint A,B,C;
	eRadius.GetWindowTextW(s); radius=_ttof(s);
	radius=((radius<=0 || radius>6)?4:radius);	
	c=COrigin; C=ConvertCW(c);
	a.x=c.x+radius*cos(alpha);
	a.y=c.y+radius*sin(alpha);
	A=ConvertCW(a);
	beta=alpha;
	while (beta<=alpha+theta)
	{
		b.x=c.x+radius*cos(beta);
		b.y=c.y+radius*sin(beta);
		B=ConvertCW(b); dc.SetPixel(B.x,B.y,RGB(200,0,0));
		beta += 0.01;
	}
	if (flag)
	{
		dc.MoveTo(C); dc.LineTo(A);
		dc.MoveTo(B); dc.LineTo(C);
	}
	s.Format(L"t=%d",t); dc.TextOutW(end.x+50,home.y-30,s);

	// determine if u[i] inside the sector
	z=0;
	for (i=1;i<=m;i++)
	{
		tau=atan(u[i].CHome.y-c.y)/(u[i].CHome.x-c.x);
		if (u[i].CHome.x>=c.x && u[i].CHome.y>=c.y)
			phi=fabs(tau);
		if (u[i].CHome.x<=c.x && u[i].CHome.y>=c.y)
			phi=PI-fabs(tau);
		if (u[i].CHome.x<=c.x && u[i].CHome.y<=c.y)
			phi=PI+fabs(tau);
		if (u[i].CHome.x>=c.x && u[i].CHome.y<=c.y)
			phi=2*PI-fabs(tau);		
		tmp=sqrt(pow(u[i].CHome.x-c.x,2.0)+pow(u[i].CHome.y-c.y,2.0));
		if ((phi >=alpha && phi<= beta) && (tmp<=radius))
		{
			z++;
			Q[z][t]=i;
		}
	}
	ShowTable();
}

void CCode9A::ShowTable()
{
	CString s;
	int i,j;
	table.DestroyWindow();
	table.Create(WS_VISIBLE | WS_CHILD | WS_BORDER | LVS_REPORT
			| LVS_NOSORTHEADER,CRect(end.x+20,home.y+200,
			end.x+350,end.y),this,idc++);
	for (j=0;j<=t;j++)	// j=column
	{
		s.Format(L"%d",j);
		table.InsertColumn(j,s,LVCFMT_CENTER,30);
	}
	for (i=1;i<=m;i++)	// i=row
	{
		if (Q[i][0]>=1 && Q[i][0]<=m)
		{
			s.Format(L"%d",Q[i][0]); table.InsertItem(i-1,s,0);
		}
		for (j=1;j<=t;j++)
			if (Q[i][j]>=1 && Q[i][j]<=m)
			{
				s.Format(L"%d",Q[i][j]); table.SetItemText(i-1,j,s);
			}
	}
}

void CCode9A::OnOmnidirectional()
{
	alpha=0; theta=360;
	alpha *= PI/180; theta *= PI/180;
	Cover(0);
	t++;
}

void CCode9A::OnDirectional()
{
	CString s;
	eAlpha.GetWindowTextW(s); alpha=_ttof(s);
	eTheta.GetWindowTextW(s); theta=_ttof(s);
	alpha *= PI/180; theta *= PI/180;
	Cover(1);
	t++;
}

void CCode9A::OnPaint()
{
	CPaintDC dc(this);
	CRect rct;
	CPen pBlack(PS_SOLID,2,RGB(0,0,0));
	dc.SelectObject(fArial10);
	dc.TextOutW(home.x+20,home.y-50,L"#Targets (2-50)");
	rct=CRect(home.x-2,home.y-2,end.x+2,end.y+2);
	dc.SelectObject(pBlack);
	dc.Rectangle(rct);
}

void CCode9A::OnCompute()
{
	CString s;
	bOmni.DestroyWindow(); bDir.DestroyWindow();
	eRadius.DestroyWindow(); eAlpha.DestroyWindow(); eTheta.DestroyWindow();
	sRadius.DestroyWindow(); sAlpha.DestroyWindow(); sTheta.DestroyWindow();
	eW.GetWindowText(s); m=_ttoi(s);
	m=((m<=0 && m>M)?10:m);
	Initialize(); DrawNodes();
	sRadius.Create(L"Radius (1-6)",WS_CHILD | WS_VISIBLE | SS_CENTER, 
		CRect(CPoint(end.x+10,home.y+5),CSize(80,20)),this,idc++);	
	eRadius.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(end.x+100,home.y),CSize(70,25)),this,idc++);
	sAlpha.Create(L"Alpha",WS_CHILD | WS_VISIBLE | SS_CENTER, 
		CRect(CPoint(end.x+30,home.y+45),CSize(50,20)),this,idc++);
	eAlpha.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(end.x+100,home.y+40),CSize(70,25)),this,idc++);
	sTheta.Create(L"Theta",WS_CHILD | WS_VISIBLE | SS_CENTER, 
		CRect(CPoint(end.x+30,home.y+85),CSize(50,20)),this,idc++);
	eTheta.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(end.x+100,home.y+80),CSize(70,25)),this,idc++);
	bOmni.Create(L"Omnidirectional",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(end.x+20,home.y+130),CSize(200,25)),this,IDC_OMNI);
	bDir.Create(L"Directional",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(end.x+20,home.y+170),CSize(200,25)),this,IDC_DIR);

}

void CCode9A::DrawNodes()
{
	CClientDC dc(this);
	CString s;
	CBrush bGray(RGB(100,100,100));	
	CBrush bRed(RGB(200,0,0));
	CBrush bWhite(RGB(255,255,255));
	CRect rct;
	rct=CRect(home.x,home.y,end.x,end.y);
	dc.FillRect(rct,&bWhite);
	rct=CRect(WOrigin.x-5,WOrigin.y-5,WOrigin.x+5,WOrigin.y+5);
	dc.FillRect(rct,&bRed);
	dc.SelectObject(fArial6);
	for (int i=1;i<=m;i++)
	{
		rct=CRect(u[i].WHome.x,u[i].WHome.y,u[i].WHome.x+5,u[i].WHome.y+5);
		dc.FillRect(rct,&bGray);
		s.Format(L"%d",i); dc.TextOutW(u[i].WHome.x-9,u[i].WHome.y-8,s);
	}
	dc.SetTextColor(RGB(0,0,0)); dc.SelectObject(fArial8);
}

void CCode9A::Initialize()
{
	t=0;
	srand(time(0));
	for (int i=1;i<=M;i++)
	{
		u[i].WHome.x=home.x+10+rand()%(end.x-home.x-30);
		u[i].WHome.y=home.y+10+rand()%(end.y-home.y-30);
		u[i].CHome=ConvertWC(u[i].WHome);
	}
	COrigin.x=0.0; COrigin.y=0.0;
	WOrigin=ConvertCW(COrigin);
	bTarget.DestroyWindow();
}

CPoint CCode9A::ConvertCW(PT p)		// converts C to W
{
	CPoint q;
	double m1,c1,m2,c2;
	m1=(double)(end.x-home.x)/(CEnd.x-CHome.x);	
	c1=(double)(home.x-CHome.x*m1);
	m2=(double)(end.y-home.y)/(CEnd.y-CHome.y);	
	c2=(double)(home.y-CHome.y*m2);
	q.x=p.x*m1+c1; q.y=p.y*m2+c2;
	return q;
}

PT CCode9A::ConvertWC(CPoint q)		// converts C to W
{
	PT p;
	double m1,c1,m2,c2;
	m1=(CEnd.x-CHome.x)/(double)(end.x-home.x);	
	c1=CHome.x-(double)home.x*m1;
	m2=(CEnd.y-CHome.y)/(double)(end.y-home.y);	
	c2=CHome.y-(double)home.y*m2;
	p.x=q.x*m1+c1; p.y=q.y*m2+c2;
	return p;
}
