// Code9A.h
#include <afxwin.h>
#include <fstream>
#include <afxcmn.h>
#define IDC_COMPUTE 500
#define IDC_NEWGRAPH 501
#define IDC_OMNI 502
#define IDC_DIR 503
#define M 50	// max #targets
using namespace std;

typedef struct		// Cartesian points
{
	double x,y;
} PT;

typedef struct
{
	PT CHome;
	CPoint WHome;
} TARGET;

class CCode9A : public CFrameWnd
{
private:
	TARGET u[M+1];	
	PT COrigin;
	CPoint WOrigin;
	double radius,alpha,theta;
	int Q[M+1][M+1];
	int idc,m,t,z;	// m=#targets, z=#targets detected, t=time
	CListCtrl table;
	CEdit eW,eRadius,eAlpha,eTheta;
	CStatic sRadius,sAlpha,sTheta,sTime;
	CButton bCompute,bTarget,bNGraph;
	CButton bOmni,bDir;
	CPoint home,end;	// Windows home, end
	CFont fArial6,fArial8,fArial10;
	PT CHome,CEnd;	// CHome,CEnd=Cartesian home,end	
public:
	CCode9A();
	~CCode9A()		{}
	void Initialize();
	CPoint ConvertCW(PT);
	PT ConvertWC(CPoint);
	void DrawNodes(),Cover(bool),ShowTable();
	afx_msg void OnCompute();
	afx_msg void OnNewGraph();
	afx_msg void OnOmnidirectional();
	afx_msg void OnDirectional();
	afx_msg void OnPaint();
	DECLARE_MESSAGE_MAP();
};

class CMyWinApp : public CWinApp
{
public:
	virtual BOOL InitInstance();
}; 
CMyWinApp  MyApplication;

BOOL CMyWinApp::InitInstance()
{
	m_pMainWnd = new CCode9A;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	return TRUE;
}
