// Code9B.cpp
#include "Code9B.h"
#define PI 3.142

BEGIN_MESSAGE_MAP(CCode9B,CFrameWnd)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_COMPUTE,OnCompute)
	ON_BN_CLICKED(IDC_ANGLE,ActivateSensor)
END_MESSAGE_MAP()

CCode9B::CCode9B()
{
	idc=400;
	Create(NULL,L"WSN Target Coverage",WS_OVERLAPPEDWINDOW,CRect(0,0,1000,800));
	WHome=CPoint(10,70); WEnd=CPoint(600,660);
	CHome.x=-5; CHome.y=5; CEnd.x=5; CEnd.y=-5;
	enS.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(WHome.x+130,WHome.y-50),CSize(100,25)),this,idc++);
	enT.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(WHome.x+400,WHome.y-50),CSize(100,25)),this,idc++);
	bCompute.Create(L"Compute",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(WHome.x+600,WHome.y-50),CSize(150,25)),this,IDC_COMPUTE);
	fArial6.CreatePointFont(60,L"arial");
	fArial8.CreatePointFont(80,L"arial");
	fArial10.CreatePointFont(100,L"arial");
}

void CCode9B::OnPaint()
{
	CPaintDC dc(this);
	CRect rct;
	CPen pBlack(PS_SOLID,2,RGB(0,0,0));
	dc.SelectObject(fArial10);
	dc.TextOutW(WHome.x+20,WHome.y-50,L"#Sensors (2-15)");
	dc.TextOutW(WHome.x+290,WHome.y-50,L"#Targets (2-5)");
	rct=CRect(WHome.x-2,WHome.y-2,WEnd.x+2,WEnd.y+2);
	dc.SelectObject(pBlack);
	dc.Rectangle(rct);
}

void CCode9B::OnCompute()
{
	CString s;
	int i,j;
	enS.GetWindowText(s); m=_ttoi(s);
	enT.GetWindowText(s); n=_ttoi(s);
	m=((m<=M)?m:M); n=((n<=N)?n:N);
	Initialize();
	sTime.Create(L"t=0",WS_CHILD | WS_VISIBLE | SS_CENTER, 
		CRect(CPoint(WEnd.x+30,WHome.y-15),CSize(50,20)),this,idc++);
	sA[0].Create(L"Alpha",WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(WEnd.x+30,WHome.y+20),CSize(50,20)),this,idc++);
	sB[0].Create(L"Beta",WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(WEnd.x+90,WHome.y+20),CSize(50,20)),this,idc++);
	sPow[0].Create(L"Pow",WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER, 
		CRect(CPoint(WEnd.x+150,WHome.y+20),CSize(50,20)),this,idc++);
	bSensor.Create(L"Activate Sensors",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(WEnd.x+10,WHome.y+50+25*m),CSize(200,30)),this,IDC_ANGLE);
	for (i=1;i<=m;i++)
	{
		s.Format(L"%d",i);
		sv[i].Create(s,WS_CHILD | WS_VISIBLE | SS_CENTER, 
			CRect(CPoint(WEnd.x+10,WHome.y+50+25*(i-1)),CSize(18,20)),this,idc++);
		sA[i].Create(L"",WS_CHILD | WS_VISIBLE | SS_CENTER, 
			CRect(CPoint(WEnd.x+30,WHome.y+50+25*(i-1)),CSize(50,20)),this,idc++);
		sB[i].Create(L"",WS_CHILD | WS_VISIBLE | SS_CENTER,
			CRect(CPoint(WEnd.x+90,WHome.y+50+25*(i-1)),CSize(50,20)),this,idc++);
		s.Format(L"%.1lf",v[i].Power);
		sPow[i].Create(s,WS_CHILD | WS_VISIBLE | SS_CENTER, 
			CRect(CPoint(WEnd.x+150,WHome.y+50+25*(i-1)),CSize(50,20)),this,idc++);
		for (j=1;j<=5;j++)
			sR[i][j].Create(L"",WS_CHILD | WS_VISIBLE | SS_CENTER,
				CRect(CPoint(WEnd.x+210+30*(j-1),WHome.y+50+25*(i-1)),CSize(25,20)),this,idc++);	
	}
	DrawNodes();
}

void CCode9B::DrawNodes()
{
	CClientDC dc(this);
	CString s;
	int i;
	CBrush bGray(RGB(100,100,100));
	CBrush bWhite(RGB(255,255,255));
	CBrush bRed(RGB(200,0,0));
	CRect rct;
	rct=CRect(WHome.x,WHome.y,WEnd.x,WEnd.y);
	dc.FillRect(rct,&bWhite);
	dc.SelectObject(fArial6);
	for (i=1;i<=m;i++)
	{
		rct=CRect(v[i].WHome.x,v[i].WHome.y,v[i].WHome.x+5,v[i].WHome.y+5);
		dc.FillRect(rct,&bGray);
		s.Format(L"%d",i); dc.TextOutW(v[i].WHome.x-9,v[i].WHome.y-8,s);
	}
	dc.SelectObject(bRed);
	dc.SetTextColor(RGB(200,0,0)); dc.SelectObject(fArial6);
	for (i=1;i<=n;i++)
	{
		rct=CRect(u[i].WHome.x,u[i].WHome.y,u[i].WHome.x+10,u[i].WHome.y+10);
		s.Format(L"%d",i); dc.TextOutW(u[i].WHome.x-8,u[i].WHome.y-8,s);
		dc.Ellipse(rct);
	}
	dc.SetTextColor(RGB(0,0,0)); dc.SelectObject(fArial8);
}

void CCode9B::ActivateSensor()
{
	CClientDC dc(this);
	CRect rct;
	CString s;
	int i,j,k;
	double h,tmp,phi,theta;		// h is increment
	PT a,b,c;
	CPoint A,B,C;		//C=center, A=begin, B=WEnd
	DrawNodes(); t++;
	s.Format(L"t=%d",t); sTime.SetWindowTextW(s);
	for (i=1;i<=m;i++)
	{
		for (j=1;j<=n;j++)
			sR[i][j].SetWindowTextW(L"");
		if (v[i].status!=2)
			v[i].status=rand()%2;
		if (v[i].status==1)
		{
			v[i].Power--;
			if (v[i].Power<=0)
			{
				v[i].Power=0; v[i].status=2;
			}
			v[i].alpha=(double)(1+rand()%360);
			theta=(double)(1+rand()%180);
			if (theta==0.0)
				theta=30.0;
			v[i].beta=v[i].alpha+theta;
			if (v[i].beta>360)
				v[i].beta=360;
			s.Format(L"%.0lf",v[i].alpha); sA[i].SetWindowText(s);
			s.Format(L"%.0lf",v[i].beta); sB[i].SetWindowText(s);
			s.Format(((v[i].Power>0)?L"%.1lf":L"dead"),v[i].Power);
			sPow[i].SetWindowTextW(s);
			v[i].alpha *= PI/180; v[i].beta *= PI/180;
			h=(v[i].beta-v[i].alpha)/200;
			c=v[i].CHome; C=ConvertCW(c); 
			a.x=c.x+v[i].R*cos(v[i].alpha);
			a.y=c.y+v[i].R*sin(v[i].alpha);
			A=ConvertCW(a);
			Cover(A,C,v[i].alpha);
			rct=CRect(WHome.x+3,WHome.y+3,WEnd.x-3,WEnd.y-3);
			tmp=v[i].alpha;
			while (tmp<=v[i].beta)
			{
				b.x=c.x+v[i].R*cos(tmp);
				b.y=c.y+v[i].R*sin(tmp);
				B=ConvertCW(b);
				if (rct.PtInRect(B))
					dc.SetPixel(B.x,B.y,RGB(0,0,200));
				tmp += h;
			}
			Cover(B,C,v[i].beta);
			for (j=1;j<=n;j++)
			{
				phi=atan((u[j].CHome.y-v[i].CHome.y)
					/(u[j].CHome.x-v[i].CHome.x));
				if (u[j].CHome.x>v[i].CHome.x && u[j].CHome.y>v[i].CHome.y)
					phi=phi;
				if (u[j].CHome.x<=v[i].CHome.x && u[j].CHome.y>=v[i].CHome.y)
					phi=PI-fabs(phi);
				if (u[j].CHome.x<=v[i].CHome.x && u[j].CHome.y<=v[i].CHome.y)
					phi=PI+fabs(phi);
				if (u[j].CHome.x>=v[i].CHome.x && u[j].CHome.y<=v[i].CHome.y)
					phi=2*PI-fabs(phi);
				tmp=sqrt(pow(u[j].CHome.x-v[i].CHome.x,2.0)
					+pow(u[j].CHome.y-v[i].CHome.y,2.0));
				if ((phi >=v[i].alpha && phi<= v[i].beta) && (tmp<=v[i].R))
				{
					k=++v[i].nR[0];		// nR[0] is #targets
					v[i].nR[k]=j;		// nR[k] is target k
					s.Format(L"%d",j);
					sR[i][j].SetWindowTextW(s);
				}
			}
		}
		if (v[i].status==0 || v[i].status==2)
		{
			s.Format(L"",v[i].alpha); sA[i].SetWindowText(s);
			s.Format(L"",v[i].beta); sB[i].SetWindowText(s);
			s.Format((v[i].status==2)?L"dead":L"");
			sPow[i].SetWindowTextW(s);
		}
	}
}

void CCode9B::Cover(CPoint D,CPoint C,double theta)
{
	CClientDC dc(this);
	PT d,c;
	CRect rct;
	rct=CRect(WHome.x,WHome.y,WEnd.x,WEnd.y);
	c=ConvertWC(C); d=ConvertWC(D);
	if (rct.PtInRect(D))
	{
		dc.MoveTo(D); dc.LineTo(C);
	}
	else
	{
		if (D.x>WEnd.x)		// right of box
		{
			d=ConvertWC(WEnd); 
			d.y=c.y+(d.x-c.x)*tan(theta);
		}
		if (D.y<WHome.y)		// higher than box
		{
			d=ConvertWC(WHome); 
			d.x=c.x+(d.y-c.y)/tan(theta);
		}
		if (D.x<WHome.x)		// left of box
		{
			d=ConvertWC(WHome);
			d.y=c.y+(d.x-c.x)*tan(theta);
		}
		if (D.y>WEnd.y)
		{
			d=ConvertWC(WEnd); 
			d.x=c.x+(d.y-c.y)/tan(theta);
		}				
		D=ConvertCW(d);
		dc.MoveTo(D); dc.LineTo(C);
	}
}

void CCode9B::Initialize()
{
	int i,j;
	t=0;
	srand(time(0));
	for (i=1;i<=M;i++)
	{		
		sv[i].DestroyWindow(); sPow[i].DestroyWindow();
		sA[i].DestroyWindow(); sB[i].DestroyWindow();
		for (j=1;j<=N;j++)
			sR[i][j].DestroyWindow();
		v[i].WHome.x=WHome.x+10+rand()%(WEnd.x-WHome.x-30);
		v[i].WHome.y=WHome.y+10+rand()%(WEnd.y-WHome.y-30);
		v[i].CHome=ConvertWC(v[i].WHome);
		v[i].Power=10.0; v[i].R=3.0;
		v[i].nR[0]=0;
	}
	for (i=1;i<=N;i++)
	{
		u[i].WHome.x=WHome.x+10+rand()%(WEnd.x-WHome.x-30);
		u[i].WHome.y=WHome.y+10+rand()%(WEnd.y-WHome.y-30);
		u[i].CHome=ConvertWC(u[i].WHome);
	}
	sPow[0].DestroyWindow(); bSensor.DestroyWindow(); 
	sTime.DestroyWindow(); sA[0].DestroyWindow(); sB[0].DestroyWindow();
}

CPoint CCode9B::ConvertCW(PT p)		// converts C to W
{
	CPoint q;
	double m1,c1,m2,c2;
	m1=(double)(WEnd.x-WHome.x)/(CEnd.x-CHome.x);	
	c1=(double)(WHome.x-CHome.x*m1);
	m2=(double)(WEnd.y-WHome.y)/(CEnd.y-CHome.y);	
	c2=(double)(WHome.y-CHome.y*m2);
	q.x=p.x*m1+c1; q.y=p.y*m2+c2;
	return q;
}

PT CCode9B::ConvertWC(CPoint q)		// converts C to W
{
	PT p;
	double m1,c1,m2,c2;
	m1=(CEnd.x-CHome.x)/(double)(WEnd.x-WHome.x);	
	c1=CHome.x-(double)WHome.x*m1;
	m2=(CEnd.y-CHome.y)/(double)(WEnd.y-WHome.y);	
	c2=CHome.y-(double)WHome.y*m2;
	p.x=q.x*m1+c1; p.y=q.y*m2+c2;
	return p;
}
