// Code9A.h
#include <afxwin.h>
#include <fstream>
#define IDC_COMPUTE 500
#define IDC_ANGLE 501
#define M 15	// max #sensors
#define N 5	// max #targets
using namespace std;

typedef struct		// Cartesian points
{
	double x,y;
} PT;

typedef struct
{
	PT CHome;
	CPoint WHome;
	double alpha,beta; // alpha=start, beta=WEnd
	double R;			// radius
	double Power;
	int status;			// 0=sleep, 1=active, 2=dead
	int nR[N+1];
} SENSOR;

typedef struct
{
	PT CHome;
	CPoint WHome;
} TARGET;

class CCode9B : public CFrameWnd
{
private:
	SENSOR v[M+1];
	TARGET u[N+1];
	int idc,m,n,t;
	CEdit enS,enT;
	CStatic sv[M+1],sPow[M+1],sA[M+1],sB[M+1],sR[M+1][N+1],sTime;
	CButton bCompute,bSensor;
	CPoint WHome,WEnd;	// Windows WHome, WEnd
	CFont fArial6,fArial8,fArial10;
	PT CHome,CEnd;	// CHome,CEnd=Cartesian WHome,WEnd	
public:
	CCode9B();
	~CCode9B()		{}
	void Initialize();
	CPoint ConvertCW(PT);
	PT ConvertWC(CPoint);
	void Cover(CPoint,CPoint,double);
	void DrawNodes();
	afx_msg void OnCompute();
	afx_msg void OnPaint();
	afx_msg void ActivateSensor();
	DECLARE_MESSAGE_MAP();
};

class CMyWinApp : public CWinApp
{
public:
	virtual BOOL InitInstance();
}; 
CMyWinApp  MyApplication;

BOOL CMyWinApp::InitInstance()
{
	m_pMainWnd = new CCode9B;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	return TRUE;
}
